/*;  common.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl common.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:38:11 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/common.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

#if !defined(common_h)
#define common_h

#include <stdio.h>
#include <iostream>
#include <stdlib.h>

using namespace std;

                  //////////////////////////////////////////////////////
                  // The name of the directorys which contain the source
                  // files
                  //
                  // Example:
                  //
                  // % setenv OHYMOSSDIR "/work;/home/shiiba/Hymos/newhymos"
const char Mysdir[] = "OHYMOSSDIR";

                  //////////////////////////////////////////////////////
                  // Definition of type Boolean
                  //
                  // #define NO 0<br>
                  // #define YES 1<br>
typedef int Boolean;
#define NO 0
#define YES 1

// enum Boolean { NO, YES };

//	Definitions of utility functions

                  //////////////////////////////////////////////////////
                  // Prints the comments written in the source file
                  // 'src_file' to the file to which the file pointer
                  // 'fp_out' points. The comment which appears first
                  // below the line with line number 'src_line' and
                  // subsequent consecutive comments are printed.
void Print_comments(
  FILE* fp_out,   // the comments are printed into 'fp_out'
  char* src_file, // the comments in 'src_file' are processed
  int src_line,   // the comments appears below line number 'src_line'
                  // are processed.
  char* head = "   " // 'head' is printed at the top of each line
);
	/*
		Print_comments(FILE*,char*,int,char*)
			եΥȤν

	ե src_file ˵Ҥ줿Ȥ, fp_out λؤե˽
	Ϥޤ. Ϥϲ˽ޤ.
		ϤǤΤ // ΥȤΤ.
		"//" μʸޤǤϤ.
		src_line , src_line + 10 Ԥδ֤, ǽ˸ // Υ
		  ȤϤϤ.
		ιԤ // ΥȤФƤϤ, ʤн
		  Ϥλ.

	㤨 hello.cc ˲εҤȤ ( | ϥեƬ),
		 9  | ... ...
		10  | ... ...
		11  | // Hello world!
		12  | ... ... //     How are you?
		13  | ... // (^_^)
		14  | ... ...
		15  | // comments...
		16  | ... ... // comments...
		17  | ... ...

	Print_comments(stdout, "hello.doc", 10, "<head>") ¹Ԥ, 
	̤ stdout ˽Ϥޤ.
		|<head> Hello world!
		|<head>     How are you?
		|<head> (^_^)
	λ, "//" μʸ "<head>" μ˽ϤƤ, ȵ
	Τʤ 14 ܰʹߤΥȤϽϤƤޤ.

	head ΥǥեͤϣʤΤ, "//" θˣƥ
	Ȥ򵭽ҤƤ, Ϥϣ।ǥȤޤ.

	, ե src_file  "r" ⡼ɤǥץǤʤ, 
	åɽ, ΥȤϤޤ.

	ARGUMENT:
		fp_out	եؤΥݥ.
		src_file	ʸҤƤե̾.
		src_line	src_line ܤ, src_line + 10 ܤδ֤˻Ϥޤ륳
					ʸϤ.
		head		ʸϤȤΥإå.
					ǥեͤ, .
	*/

  ////////////////////////////////////////////////////////////////
  // Executes
  // <dl><dd>
  //   fprintf(stderr, "E : %s : %d : %s \n",
  //    src_file, src_line, title);
  // </dl>
  // and, if 'src_comments' is YES, then executes
  // also
  // <dl><dd>
  //   Print_comments(stderr, src_file, src_line);
  // </dl>
  // 'exit' is NOT executed in this function.
void Eprint(
  char* src_file, // the name of the source file
  int src_line,   // refer the comments in Print_comments
  char* title,    // string which shows the content of error briefly
  Boolean src_comments = YES
  );

  ////////////////////////////////////////////////////////////////
  // Executes
  // <dl><dd>
  //  fprintf(stderr, "E : %s : %d : %s \n",
  //    src_file, src_line, "");
  // <dd>
  //  Print_comments(stderr, src_file, src_line);
  // </dl>
  // 'exit' is NOT executed in this function.
inline void Eprint(char* src_file, int src_line,
  Boolean src_comments = YES)
  { Eprint(src_file, src_line, "", src_comments); }

  ////////////////////////////////////////////////////////////////
  // Executes
  // <dl><dd>
  //  fprintf(stderr, "W : %s : %d : %s \n",
  //    src_file, src_line, title);
  // </dl>
  // and, if 'src_comments' is YES then executes
  // <dl><dd>
  //  Print_comments(stderr, src_file, src_line);
  // </dl>
void Wprint(char* src_file, int src_line,
	        char* title, Boolean src_comments = YES);

  ////////////////////////////////////////////////////////////////
  // Executes
  // <dl><dd>
  //  fprintf(stderr, "W : %s : %d : %s \n",
  //    src_file, src_line, "");
  // <dd>
  //  Print_comments(stderr, src_file, src_line);
  // </dl>
inline void Wprint(char* src_file, int src_line,
				   Boolean src_comments = YES)
	{ Wprint(src_file, src_line, "", src_comments); }
	/*
		Eprint(char*,int,char*,Boolean)		顼åѴؿ
		Eprint(char*,int,Boolean) (inline)	顼åѴؿ
		Wprint(char*,int,char*,Boolean)		ٹåѴؿ
		Wprint(char*,int,Boolean) (inline)	ٹåѴؿ

	ޤ, Eprint(char*,int,char*,Boolean) ,
		fprintf(stderr, "E : %s : %d : %s \n", src_file, src_line, title);
	Wprint(char*,int,char*,Boolean) ,
		fprintf(stderr, "W : %s : %d : %s \n", src_file, src_line, title);
	, åʸϤޤ.

	 src_comments  YES ξ,
		Print_comments(stderr, src_file, src_line);
	¹Ԥޤ (common.h ). src_comments Υǥեͤ YES Ǥ.

	src_file, src_line ˤ, 줾ޥѿ __FILE__, __LINE__ Ϥ
	Ʋ.

	㤨, test.cc ˲Τ褦˵Ҥ ( | ϥեƬ), ¹Ԥ,
		10  |  if (a == NULL)
		11  |      Eprint(__FILE__, __LINE__, "Now, a == NULL.", YES);
		12  |          // a ͤǤ.
		13  |          //     ͤǤ
		14  | ... ... ...
	a  NULL λ stdout ,
		|E : test.cc 11 : Now, a == NULL.
		|    a ͤǤ.
		|        ͤǤ
	ȽϤޤ.

	¿Τ, title, src_comments Ǥդ˾άƹޤ.

	ARGUMENT:
		src_file		顼ȯե̾. ޥѿ __FILE__ Ϥ.
		src_line		顼ȯֹ. ޥѿ __LINE__ Ϥ.
		title			顼ƤΥȥʸ. "" ξϽϤʤ.
						ǥե "".
		src_comments	ؿ Print_comments ¹Ԥ뤫ݤΥե饰.
						YES ξ, src_file ˵Ҥ // ʸ
						Ϥ, NO ξϽϤʤ.
						ǥե YES.
	*/

  ////////////////////////////////////////////////////////////////
  // Prints error message showing the occurence of
  // memory shortage and if src_comments is YES then
  // execute
  // <dl><dd>
  // Print_comments(stderr, src_file, src_line);
  // </dl>
void Eprint_memory(
  char* src_file,       // the name of the source file in which error
                        // occured
  int src_line,         // the line number where error occured
  char* array_typ,      // the type name of the memory which the user
                        // tried to acquire. ex. "int"
  int array_len,        // the array size
  Boolean src_comments  // whether print the comments in the source file
                        // or not
    // Example
    //  if ((string = new char[16]) == NULL) &(
    //    Eprint_memory(__FILE__, __LINE__, "char", 16, YES);
    //    exit(1);
    //    // memory allocation error
    //  &)
);

  ////////////////////////////////////////////////////////////////
  // Prints error message showing the occurence of
  // memory shortage. Executes
  // <dl><dd>
  //   Eprint_memory(src_file, src_line, array_typ,
  //                 0, src_comments)
  // </dl>
inline void Eprint_memory(char* src_file, int src_line,
						  char* array_typ,
						  Boolean src_comments)
	{ Eprint_memory(src_file, src_line, array_typ, 0, src_comments); }

  ////////////////////////////////////////////////////////////////
  // Prints error message showing the occurence of
  // memory shortage. Executes
  // <dl><dd>
  // Eprint_memory(src_file, src_line, "", 0, src_comments)
  // </dl>
inline void Eprint_memory(char* src_file, int src_line,
						  Boolean src_comments = YES)
	{ Eprint_memory(src_file, src_line, "", 0, src_comments); }
	/*
		Eprint_memory(char*,int,char*,int,Boolean)
			­Υ顼åѴؿ
		Eprint_memory(char*,int,char*,Boolean) (inline)
			­Υ顼åѴؿ
		Eprint_memory(char*,int,Boolean) (inline)
			­Υ顼åѴؿ

	­Υ顼å stderr ˽Ϥ, src_comments  YES
	ξ,
		Print_comments(stderr, src_file, src_line);
	¹Ԥޤ (common.h ). src_comments Υǥեͤ YES Ǥ.

	src_file, src_line ˤ, 줾ޥѿ __FILE__, __LINE__ Ϥ
	Ʋ.

	㤨, test.cc ˲Τ褦˵Ҥ ( | ϥեƬ), ¹Ԥ,
		10  |  if ((string = new char[16]) == NULL)
		11  |      Eprint_memory(__FILE__, __LINE__, "char", 16, YES);
		12  |          // ­Ǥ.
		13  |          //     ǰǤ.
	new ˤݤ˼Ԥ, stderr ,
		|E : test.cc 11 : Insufficient memory (char x 16).
		|    ­Ǥ.
		|        ǰǤ.
	ȽϤޤ.

	array_typ, array_len, src_comments Ǥդ˾άƹޤ.

	ARGUMENT:
		src_file		顼ȯե̾. ޥѿ __FILE__ Ϥ.
		src_line		顼ȯֹ. ޥѿ __LINE__ Ϥ.
		array_typ		ݤ褦Ȥη̾. "int", "char" ʤ.
						"" ϤϽϤʤ.
						ǥե "".
		array_len		Ĺ. 0 ϤϽϤʤ.
						ǥե 0.
		src_comments	ؿ Print_comments ¹Ԥ뤫ݤΥե饰.
						YES ξ, src_file ˵Ҥ // ʸ
						Ϥ, NO ξϽϤʤ.
						ǥե YES.
	*/

  //////////////////////////////////////////////////////////////////////
  // Print a error message telling that a file cannnot be opened.
  // If src_comments is YES, then execute
  // <dl><dd>
  //   Print_comments(stderr, src_file, src_line);
  // </dl>
void Eprint_fopen(
  char* src_file, // the name of the source program file where the error
                  // occured.
  int src_line,   // the line number where the error occured.
  char* fname,    // the name of the file which cannot be opened.
  char* mode,     // the file open mode
  Boolean src_comments = YES
  //
  // Example
  //   FILE *fp = fopen("abc.dat", "r");
  //   if (fp == NULL) &(
  //      Eprint_fopen(__FILE__, __LINE__, "abc.dat", "r", YES);
  //      // Cannot open the file.
  //   &)
  //
  );
	/*
		Eprint_fopen(char*,int,char*,char*,Boolean)
			ե륪ץΥ顼åѴؿ

	ե򥪡ץǤʤΥ顼å stderr ˽Ϥ,
	src_comments  YES ξ,
		Print_comments(stderr, src_file, src_line);
	¹Ԥޤ (common.h ). src_comments Υǥեͤ YES Ǥ.

	src_file, src_line ˤ, 줾ޥѿ __FILE__, __LINE__ Ϥ
	Ʋ.

	㤨, test.cc ˲Τ褦˵Ҥ ( | ϥեƬ), ¹Ԥ,
		10  |  FILE *fp = fopen("abc.dat", "r");
		11  |  if (fp == NULL)
		12  |      Eprint_fopen(__FILE__, __LINE__, "abc.dat", "r", YES);
		13  |          // ե뤬ץǤޤ.
		14  |          //     ǰǤ.
	ե abc.dat  "r" ⡼ɤǥץǤʤ, stderr ,
		|E : test.cc 11 : Cannot open file 'abc.dat' (mode "r").
		|    ե뤬ץǤޤ.
		|        ǰǤ.
	ȽϤޤ.

	src_comments Ǥդ˾άƹޤ.

	ARGUMENT:
		src_file		顼ȯե̾. ޥѿ __FILE__ Ϥ.
		src_line		顼ȯֹ. ޥѿ __LINE__ Ϥ.
		fname			ץ󤹤եΥե̾.
		mode			ե򥪡ץ󤹤Υ⡼.
		src_comments	ؿ Print_comments ¹Ԥ뤫ݤΥե饰.
						YES ξ, src_file ˵Ҥ // ʸ
						Ϥ, NO ξϽϤʤ.
						ǥե YES.
	*/

// *********************************************************************
// ʸϡTue Aug 16 17:47:28 1994 ʸ˽­ޤ


  ////////////////////////////////////////////////////////////////
  // Checks the status of istream 's'.
  //
  // If the status is in such an error state from which it is
  // impossible to recover, then prints error message and exits.
  //
  // If the status is 'fail' state, then reset the error state to
  // normal state, and reads in the character which caused the
  // error state, and returns the character.
  //
  // If the status is normal, returns '\0'
  //
  // istream s ξ֤Ĵ١ǽΥ顼֤ˤСΤ褦
  // 顼åɸ२顼Ϥ˽񤭽Фơexit ޤfail
  // ֤ˤС顼֤äΥ顼θˤʤäȻפ
  // 1ʸɤߤʸ֤ޤs ξ֤ǤС
  // '\0' ֤ޤ
char pick_char(istream& s);


  ////////////////////////////////////////////////////////////////
  // Reads in characters from istream 's'.  Skips whites spaces
  // and charater 'c'.  Character c is skipped only once and when
  // character c is encountered in the second time, character c is
  // pushed back to the stream 's', and exits from the function.
  //
  // Example
  // <dl><dd>
  //   skip_white_and_char(cin, '\"');
  // </dl>
void skip_white_and_char(istream& s, char c);

	// istream s 顤ʸɤ߹ߡʸ c ɤФ
	// ޤʸ c ɤФΤϣ٤ǡʸ c 
	// ˽ФƤϡХåեᤷơλޤ

  ////////////////////////////////////////////////////////////////
  // DATA2STR_BUFFSIZE
  //
  // ǡʸѴʸΥ
const int DATA2STR_BUFFSIZE = 256;

        ////////////////////////////////////////////////////////////////
        // Define macro. See (File "libohymos.h" "DEFINE MACRO")
        //
        // new ˤäƥݤʸμ¹Ԥθ, ꤬ݤ줿
        // å륳ɤû񤯤ޤp ,
        // new ͤݥ󥿤Ǥݥ󥿤ͤ NULL ʤ,
        // ե̾ȹԿ񤤤 exit ޤ
#define NEWCHECK(p) \
  if (!p) { cerr << "Not enough memory : \n\t" \
                  << __FILE__ << ":" << __LINE__  << "\n"; exit(1); }

  ////////////////////////////////////////////////////////////////
  // Transform string "str" written in "simple data format for
  // input and output" into a data string "dstr".
  // The area for creating the data string "dstr" must be prepared in
  // the unit which calls this function before this function is
  // called.  "dstrSize" is the size of the prepared area "dstr".
void str2dstr(
  char* str,
  char* dstr,
  int dstrSize
  );

  //
  // For example,
  //   str:   123  456 "abc def"
  //   dstr:  123 \0 456 \0 abc def \0\0

  ////////////////////////////////////////////////////////////////
  // Read character sequence untill it reads the character c. The
  // character sequence including c will be thrown away.
void ignore(FILE* fp, char c);

#endif	// ! common_h

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

/*; end of file */
