/*;  element.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl element.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:05:17 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/element.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  Implementation of class Element

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>			//; time_t , tm 

#include "common.h"			//; ץˤ붦
#include "list.h"			//; 饹 List 
#include "object.h"			//; 饹 Object 
#include "port.h"			//; 饹 Port 
#include "element.h"		//; 饹 Element 
#include "send.h"			//; 饹 Send_port 

#include "data2str.h"			//; ǡѴؿ

//;	饹 Element Υдؿ

Element::OperationFlag Element::Do_initial_work(void)
{
	if (initialworkdone_p == YES) return E_ALREADY;

	if (Initial_work() != YES) return E_UNDONE;

	initialworkdone_p = YES;
	return E_DONE;
}


// added by Yutaka ICHIKAWA (Mon Dec  2 13:14:00 1996)
Element::OperationFlag Element::Do_share_info(void)
{
	if (shareinfodone_p == YES) return E_ALREADY;

	if (Share_info() != YES) return E_UNDONE;

	shareinfodone_p = YES;
	return E_DONE;
}


void* Element::Get_from_list(char* c_name, char* o_name, int o_num)
{	//;		Element::Get_from_list(char*,char*,int) (define)

	if (object_list == NULL) {	//; ꥹȤ󲽺Ѥ.
		Eprint(__FILE__, __LINE__, "", YES);
			// Element::Get_from_list(char*,char*,int)
			// Cannot get object from "object_list".
			// "object_list" is pointing NULL.
			// Maybe, "object_list" has already been changed to array,
			//     or some function has set "object_list" to NULL.
		fprintf(stderr,
			"\tAsked > [%s] : \'%s\' : %d :\n", c_name, o_name, o_num);
		Oprint(); return NULL;
	}

	void* buf; object_list->Top();	//; object_list ν
	while (object_list->Look(buf) == YES)
		if (((Object*) buf)->Compare(c_name, o_name, o_num) == YES)
			return buf;		//; Υ֥Ȥȯ.

	return NULL;	//; Υ֥ȤϿƤʤä.
}

void* Element::Get_from_list(char* o_name, int o_num)
{	//;		Element::Get_from_list(char*,int) (define)

	if (object_list == NULL) {	//; ꥹȤ󲽺Ѥ.
		Eprint(__FILE__, __LINE__);
			// Element::Get_from_list(char*,int)
			// Cannot get object from "object_list".
			// "object_list" is pointing NULL.
			// Maybe, "object_list" has already been changed to array,
			//     or some function has set "object_list" to NULL.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint(); return NULL;
	}

	void* buf; object_list->Top();	//; object_list ν
	while (object_list->Look(buf) == YES)
		if (((Object*) buf)->Compare(o_name, o_num) == YES)
			return buf;		//; Υ֥Ȥȯ.

	return NULL;	//; Υ֥ȤϿƤʤä.
}


Boolean Element::Register(void* obj)
{	//;		Element::Register(void*) (define)

	if (obj == NULL)	//; .
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Register(void*)
			// Cannot register "obj" (arg).
			// "obj" is pointing NULL.

	if (object_list == NULL)	//; object_list 󲽺Ѥ.
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Register(void*)
			// Cannot register "obj" (arg).
			// "object_list" is pointing NULL.
			// Maybe, "object_list" has already been changed to array,
			//     or some function should have set "object_list" to NULL.

	//; 饹̾, ֥̾, ֹ֥.
	//; obj  Object* ʳѿǼƤ, ۾ȯ.
	char*	c_name = ((Object*) obj)->Class_name();
	char*	o_name = ((Object*) obj)->Object_name();
	int		o_num = ((Object*) obj)->Object_number();

	if (o_name == NULL || o_num == -1) {
		Eprint(__FILE__, __LINE__);
			// Element::Register(void*)
			// "obj" (arg) do not have proper object_name and
			// object_number.
		((Object*) obj)->Oprint("    registered > "); Oprint();
		exit(1);
	}

	if (Get_from_list(c_name, o_name, o_num) != NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Register(void*)
			// Cannot register "obj" (arg).
			// An object has already been registerd,
			//     whose "class_name", "object_name" and "object_number"
			//     are same as the 'obj'(arg).
			// Doubly registered same object?
			// Or registerd same name another object.
		((Object*) obj)->Oprint("    registered > "); Oprint();
		return NO;
	}

	if (((Object*) obj)->Set_owner((void*) this) != YES)
		//; owner Ѥ.
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Register(void*)
			// Cannot register "obj" (arg).

	object_list->Put_tail(obj);		//; ­ΤȤλ.

	return YES;
}


Boolean Element::Make_object_array(void**& obj_array, int& num_of_objs)
{	//;		Element::Make_object_array(void**&,int&) (define)

	if (object_list == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Make_object_array(void**&,int&)
			// "object_list" is pointing NULL.
			// "object_list" has not been made,
			//     or some function has set "object_list" to NULL.

	if (num_of_objs >= 0)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Make_object_array(void**&,int&)
			// "obj_array" has already been made,
			// Maybe, doubly changed "object_list" to "obj_array".
			// Or, some function has set 'num_of_objs'
			//     to the value greater or equal to 0.

	object_list->Make_array(obj_array, num_of_objs); return YES;
		// object_list ѥ꤬­ΤȤ, λ.
}


Boolean Element::Set_object_array(int num_of_objs)
{	//;		Element::Set_object_array(int) (define)

	if (num_of_objs < 0)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Set_object_array(int)
			// Invalid argument "num_of_objs".

	if ((number_of_objects >= 0) || (object_array != NULL))
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Set_object_array(int)
			// Doubly made "object_array".

	if ((object_array = new void*[num_of_objs]) == NULL) {
		Eprint_memory(__FILE__, __LINE__, "void*", num_of_objs);
			// Element::Set_object_array(int)
			// For "object_array".
		Oprint(); exit(5);
	}
//; added by ichikawa 1994.12.25.
//; object_array[] ν
// -------------------------------------------------------------
	for (int i = 0; i < num_of_objs; i++) object_array[i] = NULL;
// -------------------------------------------------------------
	number_of_objects = num_of_objs; return YES;
}


Boolean Element::Register(void* obj, int num)
{	//;		Element::Register(void*,int)  (define)

	if ((num < 0) || (num >= number_of_objects)) {
		Eprint(__FILE__, __LINE__);
			// Element::Register(void*,int)
			// Invalid argument "num".
		fprintf(stderr,
			"\tnum (arg) = %d, number_of_objects = %d\n",
			num, number_of_objects);
		Oprint(); return NO;
	}

	if (obj == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Registeint(void*,int)
			// Invalid argument "obj" (= NULL).

	if (object_array[num] != NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Register(void*,int)
			// Doubly set "object_array".
		fprintf(stderr, "\tDoubly set object_array[%d].\n", num);
		((Object*) object_array[num])->Oprint("    first > ");
		((Object*) obj)->Oprint("    next  > ");
		Oprint(); return NO;
	}

	object_array[num] = obj; return YES;
}


Boolean Element::Construct(void)
{	//;		Element::Construct(void) (define)

	if (object_list != NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Construct(void)
			// "object_list" is in use.
			// Cannot make "receive_port_array" and "send_port_array".

	if ((object_list = new List) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Element::Construct(void)

	//; receive_port_array κ.
	Register_receive_ports();
	if (Make_object_array(receive_port_array, number_of_receive_ports)
		!= YES) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Construct(void)
			// Cannot make "receive_port_array".

	object_list->Clear_node();

	//; send_port_array κ.
	Register_send_ports();
	if (Make_object_array(send_port_array, number_of_send_ports)
		!= YES) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Construct(void)
			// Cannot make "send_port_array".

	delete object_list; object_list = NULL; return YES;
}


// modified by Y.Ichikawa (Wed Dec 27 15:40:20 1995)
void* Element::Get_from_array(char* c_name, char* o_name, int o_num,
							  void** obj_array, int number_of_objs)
{	//;		Element::Get_from_array(char*,char*,int,void**,int) (define)

	if (number_of_objs < 0)		//; ꥹȤ󲽤Ƥʤ.
		{ Eprint(__FILE__, __LINE__); Oprint(); return NULL; }
			// Element::Get_from_array(char*,char*,int,void**,int)
			// Cannot get object from 'obj_array'.
			// 'number_of_objects' is less than 0.
			// Maybe, 'obj_array' has not been made,
			//     or some function has changed 'number_of_objects'.

	for (int k = 0; k < number_of_objs; k++)
		if (((Object*) obj_array[k])->Compare(c_name, o_name, o_num)
			== YES) return obj_array[k];	//; Υ֥Ȥȯ.

	//; Υ֥ȤϿƤʤä.
// 	Eprint(__FILE__, __LINE__);
// 		// Element::Get_from_array(char*,char*,int,void**,int)
// 		// Cannot get object from array.
// 	fprintf(stderr,
// 		"\tAsked > [%s] : \'%s\' : %d :\n", c_name, o_name, o_num);
// 	Oprint(); return NULL;

	//; 顼å Get_from_array ƤӽФ¦ǽФ
	return NULL;
}


// modified by Y.Ichikawa (Wed Dec 27 15:42:06 1995)
void* Element::Get_from_array(char* o_name, int o_num,
							  void** obj_array, int number_of_objs)
{	//;		Element::Get_from_array(char*,int,void**,int) (define)

	if (number_of_objs < 0)		//; ꥹȤ󲽤Ƥʤ.
		{ Eprint(__FILE__, __LINE__); Oprint(); return NULL; }
			// Element::Get_from_array(char*,int,void**,int)
			// Cannot get object from 'obj_array'.
			// 'number_of_objects' is less than 0.
			// Maybe, 'obj_array' has not been made,
			//     or some function has changed 'number_of_objects'.

	for (int k = 0; k < number_of_objs; k++)
		if (((Object*) obj_array[k])->Compare(o_name, o_num)
			== YES) return obj_array[k];	//; Υ֥Ȥȯ.

	//; Υ֥ȤϿƤʤä.
// 	Eprint(__FILE__, __LINE__);
// 		// Element::Get_from_array(char*,int,void**,int)
// 		// Cannot get object from array.
// 	fprintf(stderr,
// 		"\tAsked > \'%s\' : %d :\n", o_name, o_num);
// 	Oprint(); return NULL;

	return NULL;
}


// modified by Y.Ichikawa (Wed Dec 27 15:59:49 1995)
void* Element::Get_receive_port(char* c_name, char* o_name, int o_num)
{
	void* p = Get_from_array(c_name, o_name, o_num,
 						receive_port_array, number_of_receive_ports);

	//; Υ֥ȤϿƤʤä.
	if (p == NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Get_receive_port(char*,char*,int)
			// Cannot get receive_port from array.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint();
	}

	return p;
}


//; modified by Y.Ichikawa (Wed Dec 27 15:59:49 1995)
void* Element::Get_send_port(char* c_name, char* o_name, int o_num)
{
	void* p = Get_from_array(c_name, o_name, o_num,
 						send_port_array, number_of_send_ports);

	//; Υ֥ȤϿƤʤä.
	if (p == NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Get_send_port(char*,char*,int)
			// Cannot get send_port from array.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint();
	}

	return p;
}


// modified by Y.Ichikawa (Wed Dec 27 15:59:49 1995)
void* Element::Get_receive_port(char* o_name, int o_num)
{
	void* p = Get_from_array(o_name, o_num,
 						receive_port_array, number_of_receive_ports);

	//; Υ֥ȤϿƤʤä.
	if (p == NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Get_receive_port(char*,int)
			// Cannot get receive_port from array.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint();
	}

	return p;
}


// modified by Y.Ichikawa (Wed Dec 27 15:59:49 1995)
void* Element::Get_send_port(char* o_name, int o_num)
{
	void* p = Get_from_array(o_name, o_num,
 						send_port_array, number_of_send_ports);

	//; Υ֥ȤϿƤʤä.
	if (p == NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Get_send_port(char*,int)
			// Cannot get send_port from array.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint();
	}

	return p;
}


// modified by Y.Ichikawa (Wed Dec 27 15:59:49 1995)
void* Element::Get_object(char* c_name, char* o_name, int o_num)
{
	void* p = Get_from_array(c_name, o_name, o_num,
 						object_array, number_of_objects);

	//; Υ֥ȤϿƤʤä.
	if (p == NULL) {
		Eprint(__FILE__, __LINE__);
			// Element::Get_object(char*,char*,int)
			// Cannot get object from array.
		fprintf(stderr,
			"\tAsked > \'%s\' : %d :\n", o_name, o_num);
		Oprint();
	}

	return p;
}


Boolean Element::Switch(void)
{	//;		Element::Switch(void) (define)

	Boolean flag[2];	//; Ƚ.
	int k;				//; for 롼.

	flag[0] = YES;
	for (k = 0; k < number_of_receive_ports; k++)
		if (((Port*) receive_port_array[k])->Switch() != YES)
			//; ü, üҤ switch ǤʤΤ.
			flag[0] = NO;

	if (flag[0] != YES) { Eprint(__FILE__, __LINE__); Oprint(); }
		// Element::Switch(void)
		// Cannot switch those 'receive_ports'.

	flag[1] = YES;
	for (k = 0; k < number_of_send_ports; k++)
		if (((Port*) send_port_array[k])->Switch() != YES)
			//; ü, üҤ switch ǤʤΤ.
			flag[1] = NO;

	if (flag[1] != YES) { Eprint(__FILE__, __LINE__); Oprint(); }
		// Element::Switch(void)
		// Cannot switch those 'send_ports'.

	return ((flag[0] == YES) && (flag[1] == YES)) ? YES : NO;
}


Boolean Element::Are_you_ready(void)
{	//;		Element::Are_you_ready(void) (define)

	Boolean	flag = YES, buf_flag;	//; Ƚѥե饰.
	int k;							//; for 롼.

	//; receive_port γǧ.
	buf_flag = YES;
	for (k = 0; k < number_of_receive_ports; k++)
		if (((Port*) receive_port_array[k])->Are_you_ready()
			!= YES) {
			((Port*) receive_port_array[k])->Oprint();
			buf_flag = NO;
		}
	if (buf_flag != YES)
		 { Eprint(__FILE__, __LINE__); Oprint(); flag = NO; }
		// Element::Are_you_ready(void)
		// Those 'receive_ports' are not connected.
		// Or those 'relay_ports' are not connected or switched.

	//; send_port_array γǧ.
	buf_flag = YES;
	for (k = 0; k < number_of_send_ports; k++)
		if (((Port*) send_port_array[k])->Are_you_ready() != YES) {
			((Port*) send_port_array[k])->Oprint();
			buf_flag = NO;
		}
	if (buf_flag != YES)
		 { Eprint(__FILE__, __LINE__); Oprint(); flag = NO; }
		// Element::Are_you_ready(void)
		// Those 'send_ports' are not switched.
		// Or those 'relay_ports' are not connected or switched.

	//; object_array γǧ.
	buf_flag = YES;
	for (k = 0; k < number_of_objects; k++)
		if (object_array[k] == NULL) {
			fprintf(stderr, "\tobject_array[%d] has not set.\n", k);
			buf_flag = NO;
		}
	if (buf_flag != YES)
		 { Eprint(__FILE__, __LINE__); Oprint(); flag = NO; }
		// Element::Are_you_ready(void)
		// Those element of "object_array" has not set.

	return flag;
}


Boolean Element::Set_data_string(char* d_str, int d_strlen)
{	//;		Element::Set_data_string(char*,int) (define)

	if (data_string != NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Set_data_string(char*,int)
			// Doubly setting "data_string".

	if (d_str == NULL) return YES;

	size_t field_width = (d_strlen <= 0) ? strlen(d_str) + 1 : d_strlen;

	if ((data_string = new char[field_width]) == NULL) {
		Eprint_memory(__FILE__, __LINE__, "char", ((int) field_width));
			// Element::Set_data_string(char*,int)
		Oprint(); exit(5);
	}

	for (size_t k = 0; k < field_width; k++) data_string[k] = d_str[k];

	return YES;
}


Boolean Element::Get_data_string(char* d_str)
{	//;		Element::Get_data_string(char*) (define)

	if (data_string != NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Get_data_string(char*)
			// Doubly setting "data_string".

	data_string = d_str; return YES;
}


void Element::Clear_data_string(void)
{	//;		Element::Clear_data_string(void) (define)

	delete [] data_string; data_string = NULL;
}


Boolean Element::Look_data_string(char*& buffer)
{	//;		Element::Look_data_string(char*) (define)

	if (data_string == NULL) {
		Eprint(__FILE__, __LINE__); Oprint(); buffer = NULL; return NO;
			// Element::Look_data_string(char*&)
			// "data_string" has not been set.
			// "data_string" is pointing NULL.
	}

	while (*buffer != '\0') buffer++;	//; ǡʸ.

	++buffer;
	if (*buffer == '\0') { buffer--; return NO; }
		//; data_string  '\0'+'\0'.
		//; ʾǡʸǤʤ.

	return YES;
}


void Element::Parameter(FILE* fp, char*&, int, Boolean&)
{	//;		Element::Parameter(void) (define)

	Set_parameter(fp);
}

void Element::Restore_send_port_stock(void)
{
 	int k, m;   char* dstr = data_string;
	// Oprint();
 	for (int i = 0; i < number_of_send_ports; i++) {
		// printf("data_string: %s\n", dstr);
 		dstr2data(dstr, k);
		// printf("k = %d\n", k);
 		if (k != i) {
 			Eprint(__FILE__, __LINE__);
 			// k is not equal to i.

 			Oprint(); exit(1);
 		}
		// printf("data_string: %s\n", dstr);
		dstr2data(dstr, m);
		// printf("m = %d\n", m);
 		for (int j = 0; j < m; j++) {
			// printf("data_string: %s\n", dstr);
 			((Send_port*) send_port_array[i])->Send_by_string(dstr);
 		}
	}
	// Oprint(); printf("end of Restore_send_port_stock\n");
}


// added by Y.Ichikawa (Fri Nov 10 15:30:53 1995)
void Element::Rewind_current_time(void)
{
	if (current_time <= fixed_time)
		{ Wprint(__FILE__, __LINE__); Oprint(); }
			// Element::Rewind_current_time(void)
			// current_time not exceeds fixed_time.

	current_time = fixed_time;
}


// added by Y.Ichikawa (Fri Nov 10 15:30:53 1995)
void Element::Renew_fixed_time(void)
{
	if (current_time <= fixed_time)
		{ Wprint(__FILE__, __LINE__); Oprint(); }
			// Element::Renew_fixed_time(void)
			// fixed_time exceeds current_time.

	fixed_time = current_time;
}


// added by Y.Ichikawa (Sat Nov 18 18:01:17 1995)
void Element::Renew_target_time(time_t itrs)
{
	//; (*  *) OhymosOption Υå
	//; OhymosOption  DoNotGoBeyondTerminalTime Ǥ
	//; target_time ޤ terminal_time ãƤʤ硢
	//; target_time  terminal_time ·褦 itrs Ĵ롣
	//; Ǥ terminal_time ޤǷ׻äƤϡ
	//; terminal_time  target_time 
	//; ꤹ롣

	if (target_time + itrs > Terminal_time()) {
		if ((OhymosOption::Get_time_control_option() ==
			OhymosOption::DoNotGoBeyondTerminalTime) &&
			(target_time < Terminal_time())) {
			itrs = Terminal_time() - target_time;
		}
	}

	target_time += itrs;
}


// added by Y.Ichikawa (Mon Nov 20 19:49:56 1995)
time_t Element::Calculate_iteration_step(void)
{
	Eprint(__FILE__, __LINE__); Oprint();
		// Element::Calculate_iteration_time(void)
		// If you want to call me, please define me
		// in your class.
	exit(1);
}


time_t Element::Necessary_time_from(Receive_port*)
{
	return current_time;
}

time_t Element::Necessary_time_to(Receive_port*)
{
	return Next_time();
}


Boolean Element::Initial_time(time_t i_time)
{	//;		Element::Initial_time(time_t) (define)

	if (time_step >= 0) {
		if ((current_time == i_time) && (time_step == 0))
			{ Wprint(__FILE__, __LINE__); Oprint(); return YES; }
				// Element::Initial_time(time_t)
				// Cannot set initial time.
				// Doubly setting initial time to the same value.

		Eprint(__FILE__, __LINE__);
			// Element::Initial_time(time_t)
			// Cannot set initial time.
			// Doubly setting initial time.
		fprintf(stderr,
			"\tcurrent_time = %ld, time_step = %ld\n\ti_time (arg) = %ld\n",
			current_time, time_step, i_time);
		Oprint(); return NO;
	}

	current_time = i_time; time_step = 0;
	return YES;
}


void Element::Initial_state(FILE* fp, char*&, int, Boolean&)
{	//;		Element::Initial_state(void) (define)

	Set_initial_state(fp);
}

void Element::Terminal_state(FILE* fp)
{	//;		Element::Terminal_state(void) (define)

	if (fp != NULL) {
//		fprintf(fp, "\n");
		fprintf(fp, "%s %s %d\n", class_name, object_name,
				object_number);
		Save_terminal_state(fp);
		fprintf(fp, "\n");
	}
}

Boolean Element::Initial_work(void)
{	//;		Element::Initial_work(void) (define)

	if (Initial_output() == NO) return NO;
	Set_data_pack_array();
	return YES;
}

Boolean Element::Can_you_calculate0(void)
{	//;;		Element::Can_you_calculate0(void) (define)
  //; <japanese>
  //; μϤǤ褤Ƥɬסcurrent_time  Terminal_time()
  // ۤƤ뤫åɬפ
  // </japanese>

// @begin{commented out by shiiba} -------------------------------------
//  if (current_time >= Terminal_time()) return NO;
// @end{commented out by shiiba} ---------------------------------------

  Boolean reply = YES;
  int k;
  for (k = 0; k < number_of_receive_ports; k++) {
    // Check all receive ports
    time_t t_from, t_to;
    void* rp = receive_port_array[k];
    t_from = Necessary_time_from((Receive_port*)rp);
    t_to = Necessary_time_to((Receive_port*)rp);
    if (((Port*)rp)->Can_you_get_data(t_from, t_to) != YES) {
      ((Port*)rp)->Creq(); // issue calculation request
      reply = NO;
    }
  }
  return reply;
}


Boolean Element::Can_you_calculate1(void)
{	//;		Element::Can_you_calculate1(void) (define)

// @begin{commented out by shiiba} -------------------------------------
//	if (current_time >= Terminal_time()) return NO;
// @end{commented out by shiiba} ---------------------------------------

  Boolean reply = YES;
  int k;
  for (k = 0; k < number_of_receive_ports; k++) {
    // Check all receive ports
    time_t t_from;
    void *rp = receive_port_array[k];
    t_from = Necessary_time_from((Receive_port*)rp);
    if (((Port*)rp)->Can_you_get_data(t_from, t_from) != YES) {
      ((Port*)rp)->Creq(); // issue calculation request
      reply = NO;
    }
  }
  return reply;
}

void Element::Set_data_pack_array(void)
{	//;		Element::Set_data_pack_array(void) (define)

	for (int k = 0; k < number_of_send_ports; k++)
		((Port*) send_port_array[k])->Set_data_pack_array();
}


void Element::Reduce_data_pack_stock(void)
{	//;		Element::Reduce_data_pack_stock(void) (define)

	int k;	//; for 롼.

	for (k = 0; k < number_of_receive_ports; k++)
		((Port*) receive_port_array[k])->Reduce_data_pack_stock();

	for (k = 0; k < number_of_send_ports; k++)
		((Port*) send_port_array[k])->Reduce_data_pack_stock();
}


Boolean Element::Record_status(void)
{	//;		Element::Record_status(void) (define)

	if (data_string == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Element::Record_status(void)
			// Cannot print status.
			// "data_string" is pointing NULL.

	Print_status(); return YES;
}

void Element::Save_send_port_stock(FILE* fp)
{
	if (number_of_send_ports <= 0) return;
	if (fp != NULL) {
		fprintf(fp, "%s %s %d ", class_name, object_name,
				object_number);
		fprintf(fp, "(\n");
		for (int k = 0; k < number_of_send_ports ; k++) {
			fprintf(fp, "(%d) # send_ports number\n", k);
			((Send_port*) send_port_array[k])->Save_send_port_stock(fp);
		}
		fprintf(fp, ")\n");
	}
}

Boolean Element::Work0(void)
{	//;		Element::Work0(void) (define)

// @begin{commented out by shiiba} -------------------------------------
//  if (current_time >= Terminal_time()) return NO;		//; ׻Ѥ.
// @end{commented out by shiiba} ---------------------------------------

  // <japanese>
  // ׻׵ʤcurrenet_time ɸۤƤз׻
  // 
  // </japanese>
  if (mCreqp == NO && current_time >= MediumTermTargetTime()) return NO;

  Boolean calc = NO;

LOOP:	//; 롼 "LOOP" .

  //; ॹƥåפ.
  if ((time_step = Calculate_time_step()) <= 0) {
    if (time_step == 0) return NO;
    //; ॹƥåפ.
    Eprint(__FILE__, __LINE__);
    // Element::Work(void)
    // Now "time_step" is set to 0, or less than 0.
    // Check definition of pure virtual member function,
    //     "Element::Calculate_time_step".
    fprintf(stderr,
      "\tcurrent_time = %ld, time_step = %ld\n",
      current_time, time_step);
    Oprint(); return NO;
  }

  if (current_time + time_step > Terminal_time()) {
    if (OhymosOption::Get_time_control_option() ==
      OhymosOption::DoNotGoBeyondTerminalTime) {
      time_step = Terminal_time() - current_time;
    }
  }

  //; ׻γǧ.
  if (Can_you_calculate() != YES) {
    if (calc == NO) return NO;	//; ׻˽λ.
    goto FINISH;
  }

  //; ƥåפη׻.
  if (Calculate() == NO) { //; äѤ׻Ǥʤä
    if (calc == NO) return NO;
    goto FINISH;
  }

  calc = YES;
  mCreqp = NO; // reset mCreqp

  //; update current_time
  if ((current_time += time_step) >= MediumTermTargetTime()) goto FINISH;

  goto LOOP;	//; ƥåפη׻.

//; 롼 "LOOP" ޤ.

FINISH:	//; ׻ν.
  Set_data_pack_array();		//; ǡѥåκ.
  Reduce_data_pack_stock();	//; ץǡѥåξõ.

  return YES;
}


Boolean Element::Work1(void)
{	//;		Element::Work1(void) (define)

// @begin{commented out by shiiba} -------------------------------------
//  if (current_time >= Terminal_time()) return NO;
// @end{commented out by shiiba} ---------------------------------------

  // <japanese>
  // ׻׵ʤcurrenet_time ɸۤƤз׻
  // 
  // </japanese>
  if (mCreqp == NO && current_time >= MediumTermTargetTime()) return NO;

  Boolean calc = NO;

LOOP:	//; 롼 "LOOP" .

  Boolean flg_dbg;
  //; ׻γǧ.
  if ((flg_dbg = Can_you_calculate()) != YES) {
    if (calc == NO) return NO;	//; ׻˽λ.
    goto FINISH;
  }

  //; ƥåפη׻.
  if (Calculate() == NO) {
    if (calc == NO) return NO;	//; ׻˽λ.
    goto FINISH;
  }

  calc = YES;
  mCreqp = NO; // reset mCreqp

  //; ߻ (׻Ѥ߻) current_time ι.
  if (time_step <= 0) goto FINISH;
  current_time += time_step;
  if (current_time >= MediumTermTargetTime()) goto FINISH;

  goto LOOP;	//; ƥåפη׻.

//; 롼 "LOOP" ޤ.

FINISH:	//; ׻ν.
  Set_data_pack_array();		//; ǡѥåκ.
  Reduce_data_pack_stock();	//; ץǡѥåξõ.

  return YES;
}


// added by Y.Ichikawa (Fri Nov 10 17:01:17 1995)
Boolean Element::Work2(void)
{	//;		Element::Work2(void) (define)

	if (fixed_time >= Terminal_time()) return NO; //; ׻Ѥ.
	if (current_time >= target_time) return NO;   //; ¾Ԥ

	Boolean calc = NO;

  LOOP:	//; --- 롼 "LOOP" . ---

	//; ॹƥåפ.
	if ((time_step = Calculate_time_step()) <= 0) {
		if (time_step == 0) return NO;
		//; ॹƥåפ.
		Eprint(__FILE__, __LINE__);
			// Element::Work(void)
			// Now "time_step" is set to 0, or less than 0.
			// Check definition of pure virtual member function,
			//     "Element::Calculate_time_step".
		fprintf(stderr,
			"\tcurrent_time = %ld, time_step = %ld\n",
			current_time, time_step);
		Oprint(); return NO;
	}

	//; target_time 򤳤ʤ褦
	if (current_time + time_step > target_time)
		time_step = target_time - current_time;

	//; ׻γǧ.
	if (Can_you_calculate() != YES) {
		if (calc == NO) return NO;	//; ׻˽λ.
		goto FINISH;
	}

	//; ƥåפη׻.
	if (Calculate() == NO) { //; äѤ׻Ǥʤä
		if (calc == NO) return NO;
		goto FINISH;
	}

	calc = YES;

	//; ߻ (׻Ѥ߻) current_time ι.
	if ((current_time += time_step) >= target_time) goto FINISH;

	goto LOOP;	//; ƥåפη׻.

	//; --- 롼 "LOOP" ޤ. ---

  FINISH:	//; ׻ν.
	return YES;
}

// added by Y.Ichikawa (Fri Nov 10 17:01:17 1995)
Boolean Element::Do_you_reach_target_time(void)
{
	if (current_time >= target_time) return YES;
	return NO;
}


// added by Y.Ichikawa (Mon Nov 20 19:53:27 1995)
Boolean Element::Do_you_converge(void)
{
	Eprint(__FILE__, __LINE__); Oprint();
		// Element::Do_you_converge(void)
		// If you want to call me, please define me
		// in your class.
	exit(1);
}


// added by Y.Ichikawa (Thu Nov 16 14:24:47 1995)
void Element::Flush_data(void)
{
	Send_stocked_data();		//; ǡν
 	Set_data_pack_array();		//; ǡѥåκ
 	Reduce_data_pack_stock();	//; ץǡѥåξõ
}


// added by Y.Ichikawa (Mon Nov 20 19:51:47 1995)
void Element::Send_stocked_data(void)
{
	Eprint(__FILE__, __LINE__); Oprint();
		// Element::Send_stocked_data(void)
		// If you want to call me, please define me
		// in your class.
	exit(1);
}


char* Element::Get_line(FILE* fp, char* buffer, int buflen,
	Boolean& stock_p, int& iflag)
{
	char* p; char* cp;
	if (stock_p == NO) {
		while(1) {
			p = fgets(buffer, buflen, fp);
			if (p == NULL) return NULL;
			if (buffer[0] == '#') continue;
			cp = buffer;
			while (*cp == ' ' || *cp == '\t') cp++;
			if (*cp == '\n') continue;
			break;
		}
		iflag = *cp;
		return p;
	}
	else {
		stock_p = NO;
		cp = buffer;
		while (*cp == ' ' || *cp == '\t') cp++;
		iflag = *cp;
		return buffer;
	}
}

void Element::Get_line(FILE* fp, char* buffer, int buflen,
	char* fname, int line_number)
{
	char* cp;
	while(1) {
		if (fgets(buffer, buflen, fp) == NULL) {
			Eprint(fname, line_number, NO); Oprint(); exit(1);
		}
		if (buffer[0] == '#') continue;
		cp = buffer;
		while (*cp == ' ' || *cp == '\t') cp++;
		if (*cp == '\n') continue;
		break;
	}
}

void Element::Print_objects(FILE* fp, char* head, char* title,
							void** port_array, int number_of_ports)
{	//;		Element::Print_objects(FILE*,char*,char*,void**,int) (define)

	if (title != NULL) {
		fprintf(fp, "%s%s", head, title);
		Oprint(fp, "of : ");
	}
	else Oprint(fp, head);

	for (int k = 0; k < number_of_ports; k++) {
		fprintf(fp, "%s", head);
		((Object*) port_array[k])->Cprint(fp, "    ");
	}
}


void Element::Print_connection(FILE* fp, char* head)
{	//;		Element::Print_connection(FILE*,char*) (define)

	char* indent = "    ";
	int len = strlen(indent) + 1;
	len += (head != NULL) ? strlen(head) : 0;

	char* tmp = new char[len];
	if (tmp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, YES); Oprint(); exit(5); }
	// Element::Print_connection(FILE*,char*)
	strcpy(tmp, head); strcat(tmp, indent);

	int k;
	for (k = 0; k < number_of_receive_ports; k++) {
		((Port*) receive_port_array[k])->Cprint(fp, head);
		((Port*) receive_port_array[k])->Print_connection(fp, tmp);
	}

	for (k = 0; k < number_of_receive_ports; k++) {
		((Port*) send_port_array[k])->Cprint(fp, head);
		((Port*) send_port_array[k])->Print_connection(fp, tmp);
	}

	delete [] tmp;
}


// modified by Y.Ichikawa (Mon Jan  8 13:19:10 1996)
// modified by Yutaka ICHIKAWA (Mon Dec  2 11:34:25 1996)
Element::Element(char* o_name, int o_num, int num_of_objs, char* p_str)
:	Object(),
	initialworkdone_p(NO), shareinfodone_p(NO),
	object_list(NULL),
	receive_port_array(NULL), number_of_receive_ports(-1),
	send_port_array(NULL), number_of_send_ports(-1),
	object_array(NULL), number_of_objects(-1),
	data_string(NULL),
	current_time(0), time_step(-1), fixed_time(0), target_time(0),
    mCreqp(NO)
{	//;		Element::Element(char*,int,int,char*) (define)

	class_name = "Element";

	Init(o_name, o_num, num_of_objs, p_str);
}


// modified by Y.Ichikawa (Mon Jan  8 13:19:10 1996)
// modified by Yutaka ICHIKAWA (Mon Dec  2 11:35:05 1996)
Element::Element(char* o_name, int o_num, char* p_str)
:	Object(),
	initialworkdone_p(NO), shareinfodone_p(NO),
	object_list(NULL),
	receive_port_array(NULL), number_of_receive_ports(-1),
	send_port_array(NULL), number_of_send_ports(-1),
	object_array(NULL), number_of_objects(-1),
	data_string(NULL),
	current_time(0), time_step(-1), fixed_time(0), target_time(0),
    mCreqp(NO)
{	//;		Element::Element(char*,int,char*) (define)

	class_name = "Element";

	Init(o_name, o_num, 0, p_str);
}


// modified by Y.Ichikawa (Mon Jan  8 13:19:10 1996)
// modified by Yutaka ICHIKAWA (Mon Dec  2 11:35:32 1996)
Element::Element(void)
:	Object(),
	initialworkdone_p(NO), shareinfodone_p(NO),
	object_list(NULL),
	receive_port_array(NULL), number_of_receive_ports(-1),
	send_port_array(NULL), number_of_send_ports(-1),
	object_array(NULL), number_of_objects(-1),
	data_string(NULL),
	current_time(0), time_step(-1), fixed_time(0), target_time(0),
    mCreqp(NO)
{	//;		Element::Element(void) (define)

	class_name = "Element";
}


Element::~Element(void)
{	//;		Element::~Element(void) (define)

	delete object_list;
	delete [] receive_port_array;
	delete [] send_port_array;
	delete [] data_string;
    delete [] object_array;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
