/*;  libohymos.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl libohymos.html\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#) ohymos

/*
{\ {\setlength{\parskip}{4pt}% latex-mode
...
}% end of latex-mode }
*/

/*----------------------------------------------------------------------
LIBRARY
    libohymos

OVERVIEW
    2000-09-01 update

    Library "libohymos" provides classes for treating
    rainfall-runoff programs.

    <japanese>
    OHyMoS ϡ رظڥƥ๩칶ʸ
    ظ漼ʤӤ ɺҸҳ繿ҳʬ ǳ
    ȯݼ餵Ƥʸǥ빽ۥƥǤ

    OHyMoS ϡʸǥֹ¤Ūǥ벽ˡפˤäƺ뤿Υ
     ƥǡ֥Ȼظ C++ ȤäƼ¸Ƥޤ

    ֹ¤Ūǥ벽ˡפȤϡƿʸǥ˶̤ʹ¤Фơ餫
     ǥ벽Ƥġοʸǥǥϡζ̹¤Ѿ
    ƺ ԤȤˡǤ

    ߤΤȤġοʸǥ⥪֥Ȼظ C++ ȤäƵ
    Ҥ ʤФʤޤ

    OHyMoS ϼΤ褦ħäƤޤ

    <ul>
    <li>
      ǥǥȹ碌Υǥ롣

    <li>
      ѥ᥿ꡤͤꡤǡμϤʤɤϡɸಽƤ
      롣

    <li>
      ǥǥϡġȼλñ̤Ƿ׻Ǥ롣

    <li>
      ǥǥνϥǡ¾ǥǥ뤬ϥǡȤѤ
      ȤطϡüҤˤǡȤƥǥ벽롣

    <li>
      üҤˤǡǤбǤʤ硤ǥǥƱΤľܥǡ
      򴹤ľ̿ǽ롣

    <li>
      ʣǤδ֤Ǿ򴹤ʤ׻ȿ뵡ǽ롣 (Ver.
      2.0.0 ɲäޤ)

    <li>
      ήзϤκǽ֤ե˽񤭽Фǡ׻ƳǤ롣
    </ul>

    ʸϡOhymos-current (ohymos-2.4d.tgz θǡդԽΤ
    ΤǤ) βǤohymos-2.4d.tgz ˤۤбƤޤ

    OHyMoS Υ桼δ֤Ǿ򴹤뤿Υᥤ󥰥ꥹohymos-ML
    ĤƤޤ

    OHyMoS Υϡ<a
    href=http://hywr.kuciv.kyoto-u.ac.jp/ohymos.html>
    http://hywr.kuciv.kyoto-u.ac.jp/ohymos.html</a> Ǥޤ

    <a href=./doc>documents</a>
    </japanese>

HIERARCHY

    EXAMPLE
    class hierarchy from Object to I_file<T>, O_file<T>

        Object <-- Port <-- Sender_port <--+
                                           |
     +-------------------------------------+
     |
     +---   Send_port <-- Input_port <-- Input_file   <--+-- I_file<T>
                                                         |
                                         Port_type<T> <--+

        Object <-- Port <--+
                           |
     +---------------------+
     |
     +--- Receive_port <-- Output_port <-- Output_file  <--+-- O_file<T>
                                                           |
                                           Port_type<T> <--+

    --------------------------------------------------------------------
    class hierarchy from Object to Send<T>, Receive<T>, Relay<T>

    Object <-- Port <-- Sender_port <-- Send_port <--+-- Send<T>
                                                     |
                                     Port_type<T> <--+

    Object <-- Port <-- Sender_port <-- Relay_port <--+-- Relay<T>
                                                      |
                                      Port_type<T> <--+

    Object <-- Port <-- Receive_port <--+-- Receive<T>
                                        |
                        Port_type<T> <--+

    Object <-- Port <-- Receive_port <--+-- ReceiveNointp<T>
                                        |
                        Port_type<T> <--+

    --------------------------------------------------------------------
    class hierarchy from Object to Total_system

    Object <-- Element <-- Sub_system <-- Total_system

    --------------------------------------------------------------------
    class hierachy to Data

    Data_pack    <--+-- Data<T>
                    |
    Port_type<T> <--+

    --------------------------------------------------------------------

    OHyMosString

    Vary

    END

DEFINE MACROS

    The following macros are defined in common.h.

    <dl><dt> NEWCHECK(foo)
        <dd> If foo is NULL, prints error message and exit.
        <dt> YES
        <dd> #define YES 1
        <dt> NO
        <dd> #define NO 0
    </dl>

    <japanese>
    --------------------------------------------------------------------

    ĤΥޥ common.h Ƥޤ

    <dl><dt> NEWCHECK(foo)
        <dd> foo  NULL ʤ顢顼åե̾Կɽ
             ƥ Ȥޤ
        <dt> YES
        <dd> #define YES 1
        <dt> NO
        <dd> #define NO 0
    </dl>
    </japanese>

----------------------------------------------------------------------*/

/*; end of file */
