/* io_file_plus.cc
**  ----------------
**  Copy Right belongs to
**  SUZUKI, Toshiro
**    Hydrology Division, River Depertment,
**    Public Works Research Institute, Ministry of Construction
*/

#if !defined(io_file_plus_cc)
#define io_file_plus_cc

#include <stdio.h>
#include <stdlib.h>
#include <time.h>          // time_t , tm 
#include <math.h>          // ؿ log10
#include <limits.h>        // ޥ LONG_MAX

#if defined(__MSDOS__)		// OS  MS-DOS ξ
#include <sys\stat.h>		// stat 
#elif !defined(__MSDOS__)	// OS  MS-DOS Ǥʤ
#include <sys/stat.h>		// stat 
#endif

#include "data2str.h"
#include "p_tmp.h"         // üҥ饹ƥץ졼 I_file, O_file
//#include "p_tmp.cc"      // 饹ƥץ졼Ȥμ
#include "ostring.h"       // ʸ󥯥饹 OHyMosString
#include "vary.h"          // 󥯥饹 Vary

#include "io_file_plus.h"  // 饹ƥץ졼 I_file_plusO_file_plus


// дؿʳμ

Boolean Double2time_t(double src, time_t& dest)
{
    if (src > (((double) LONG_MAX) + 0.50000000000000000)
        || src < (((double) LONG_MIN) - 0.50000000000000000))
        { Eprint(__FILE__,__LINE__); return NO; }
            // Double2time_t(double, time_t&)
            // src is out of time_t (long) range.

    dest = ((time_t) src);  // ڼΤ
    src -= ((double) dest);  // src Ͼ
    dest += (src > 0.50000000000000000) ? 1 : 0;  // ͼθ
    dest -= (src < -0.50000000000000000) ? 1 : 0;  // ͼθ

    return YES;
}


// 饹ƥץ졼 I_file_plus μ

template <class T>
void I_file_plus<T>::Cprint(FILE* fp_out, char* head)
{
    I_file<T>::Cprint(fp_out, head);
    fprintf(fp_out, "%s    time_unit=%ld,time_lag=%ld\n",
            head, time_unit, time_lag);
}


template <class T>
void I_file_plus<T>::Input_data(void)
{
    // Ⱦϡؿ Input_file::Input_data(void) (@input_f.cc) ١

    int i;  // 롼׺

    (*this).Set_data_pack_array();
        // Υдؿ, 쥯饹 Send_port ǼƤޤ
        // ꥹȤ˻ĤäƤ뤫Τʤǡѥåɲäޤ
    (*this).Reduce_data_pack_stock();
        // Υдؿ, 쥯饹 Send_port ǼƤޤ
        // ׻פʸŤǡޤ

    // ʾ, ǡޤĤɤ߹ޤƤʤ˼¹ԤƤ
    // ꤬ʤ褦θƤޤ

    struct stat buf;
    if (stat((*this).object_name, &buf) != 0)
        { Eprint(__FILE__,__LINE__); (*this).Oprint(); return; }
            // Input_file::Input_data(void)
            // Cannot get status of 'input_file'
    if (buf.st_mtime <= (*this).file_time_at_input) return;  // ϥե̤

    FILE* fp = fopen((*this).object_name, "r");  // ϥե
    if (fp == NULL)
        { Eprint_fopen(__FILE__,__LINE__,(*this).object_name,"r"); (*this).Oprint(); exit(3); }
            // I_file_plus<T>::Input_data(void)

    // ϥեĹʬɤ߼Хåե
    char c_buf;
    int len = 0;  // ϥեɤ߼ХåեĹ
    i = 0;
    while ((c_buf = fgetc(fp)) != EOF) {
        i++;
        if (c_buf == '\n') { len = (len > i) ? len : i; i = 0; }
    }
    len = (len > i) ? len : i;  // ԤǤʤEOF ξθ
    if (len <= 0) { Wprint(__FILE__,__LINE__); (*this).Oprint(); fclose(fp); return; }
        // I_file_plus<T>::Input_data(void)
        // Cannot send input data. This input_file is empty.
    len++;  // '\0' Ǽ뤿
    char* line_data = new char[len];  // ϥǡʬγǼ
    if (line_data == NULL) {
        Eprint_memory(__FILE__,__LINE__,"char",len); (*this).Oprint();
            // I_file_plus<T>::Input_data(void)
            // For buffer string to read 'input_file'
        fclose(fp); exit(5);
    }

    // ϥǡ
    fseek(fp, 0, 0);  // fp եƬ᤹
    time_t t_buf;
    int line = 0;
    while (fgets(line_data, len, fp) != NULL) {  // إåν
        line++;
        if (line_data[0] != '#') break;
        switch (line_data[1]) {
            case '*':
                if (sscanf((line_data + 2), "%ld", &t_buf) != 1
                    || Set_time_unit(t_buf) == NO) {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // I_file_plus<T>::Input_data(void)
                        // Format or Value is invalid.
                    fprintf(stderr, "at line number %d.\n", line);
                    fclose(fp); exit(1);
                }
                break;
            case '+':
                if (sscanf((line_data + 2), "%ld", &t_buf) != 1
                    || Set_time_unit(t_buf) == NO) {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // I_file_plus<T>::Input_data(void)
                        // Format or Value is invalid.
                    fprintf(stderr, "at line number %d.\n", line);
                    fclose(fp); exit(1);
                }
                break;
            default:
                break;
        }
    }

    // fgets == NULL  while 롼פλȡline_data[0] == '\0'
    //  do 롼פäƤʤK&R  fgets μ򻲾ȡ

    void* buf_dp;
    line--;
    do {
        line++;
        for (i = 0; i < len; i++)
            if (line_data[i] != ' ' || line_data[i] != '\t') break;
        if (line_data[0] == '#' || i >= len
            || line_data[i] == '\n' || line_data[i] == '\0') continue;
            // ȹԡԤξ硢Ԥ
        if (Make_data_pack(len, line_data, buf_dp) == NO) {
            Eprint(__FILE__,__LINE__); (*this).Oprint();
                // I_file_plus<T>::Input_data(void)
            fprintf(stderr, "at line number %d.\n", line);
            fclose(fp); exit(1);
        }
        if (buf_dp == NULL) continue;  // ǡѥåʤ硢Ԥ
        (*this).Stock(buf_dp);
    } while (fgets(line_data, len, fp) != NULL);

    fclose(fp); delete [] line_data;

    (*this).Set_data_pack_array(); return;
}


template <class T>
Boolean I_file_plus<T>::Make_data_pack(int len, char* line_data, void*& dp)
{
    // ¬ɽν
    char no_data = '*';
        // ǡ͵ 2 İʾ '*' ΤߤϢ³Ϸ¬ : dp = NULL
        // '*'  1 ĤΤߤξ char ǡȸʤ
    int i;  // 롼׺

    // ǡ͵ܤ 1 ʸܤ򥵡
    int vh;  // ǡͤƬ
    for (vh = 0; vh < len; vh++)
        if (line_data[vh] != ' ' && line_data[vh] != '\t') break;
    for (i = 0; i < (*this).object_number; i++) {  // object_number ޤǤ
        switch (line_data[vh]) {
            case '\n':
            case '\0':
                Eprint(__FILE__,__LINE__); (*this).Oprint();
                    // I_file_plus<T>::Make_data_pack(char*)
                    // Invalid format. Shortage of data number.
                    // String of the line is following.
                fprintf(stderr, "    \"%s\"\n", line_data);
                return NO;
            case '\'':
            case '\"':
				{
                char c = line_data[vh];
                for (vh++; vh <len; vh++) {
                    if (line_data[vh] == '\n' || line_data[vh] == '\0') {
                        Eprint(__FILE__,__LINE__); (*this).Oprint();
                            // I_file_plus<T>::Make_data_pack(char*)
                            // Invalid format. String data of Input file.
                            // String of the line is following.
                        fprintf(stderr, "    \"%s\"\n", line_data);
                        return NO;
                    }
                    if (line_data[vh] == c) { vh++; break; }
                }
                if (line_data[vh] != ' ' && line_data[vh] != '\t') {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // I_file_plus<T>::Make_data_pack(char*)
                        // Invalid format. Shortage of data number.
                        // String of the line is following.
                    fprintf(stderr, "    \"%s\"\n", line_data);
                    return NO;
                }
                break;
			    }
            default:
                for (; vh < len; vh++) {
                    if (line_data[vh] == '\n' || line_data[vh] == '\0') {
                        Eprint(__FILE__,__LINE__); (*this).Oprint();
                            // I_file_plus<T>::Make_data_pack(char*)
                            // Invalid format. Shortage of data number.
                            // String of the line is following.
                        fprintf(stderr, "    \"%s\"\n", line_data);
                        return NO;
                    }
                    if (line_data[vh] == ' ' || line_data[vh] == '\t') break;
                }
                break;
        }
        for (; vh < len; vh++)
            if (line_data[vh] != ' ' && line_data[vh] != '\t') break;
    }

    // line_data[vh] ϥǡͤƬʸ
    int vl;  // ǡĹʸ
    switch (line_data[vh]) {
        case '\0':
        case '\n':
            Eprint(__FILE__,__LINE__); (*this).Oprint();
                // I_file_plus<T>::Make_data_pack(char*)
                // Invalid format. Shortage of data number.
                // String of the line is following.
            fprintf(stderr, "    \"%s\"\n", line_data);
            return NO;
        case '\'':
        case '\"':
            { char c = line_data[vh];
            for (vh++, vl = vh; vl < len; vl++) {

                if (line_data[vl] == '\n' || line_data[vl] == '\0') {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // I_file_plus<T>::Make_data_pack(char*)
                        // Invalid format. String data of Input file.
                        // String of the line is following.
                    fprintf(stderr, "    \"%s\"\n", line_data);
                    return NO;
                }
                if (line_data[vl] == c) break;
            }
		    vl -= vh;
            break;
		    }
        default:
            for (vl = vh; vl < len; vl++)
                if (line_data[vl] == ' ' || line_data[vl] == '\t'
                    || line_data[vl] == '\n' || line_data[vl] == '\0') break;
            vl -= vh;

            // ¬
            for (i = 0; i < vl; i++) if (line_data[vh + i] != no_data) break;
            if (i == vl && vl >= 2) { dp = NULL; return YES; }
            break;
    }

    // ǡϿɤ߼ꡦѴ
    double t_buf0;
    sscanf(line_data, "%lf", &t_buf0);  // ɤ߼
    t_buf0 += ((double) time_lag);  // Ѵ
    t_buf0 *= ((double) time_unit);  // Ѵ
    time_t t_buf1;
    if (Double2time_t(t_buf0, t_buf1) == NO) {
        Eprint(__FILE__,__LINE__); (*this).Oprint();
            // I_file_plus<T>::Make_data_pack(int,char*,void*&)
        fprintf(stderr, "    \"%s\"\n", line_data);
        return NO;
    }

    // ǡͤν񤭹
//     int digit = ((int) log10(LONG_MAX)) + 1;
    int digit = ((int) log10((double)LONG_MAX)) + 1;
    int buf_len = digit + 1 + vl + 1;
    char* buf = new char[buf_len];  // 
    if (buf == NULL) {
        Eprint_memory(__FILE__,__LINE__,"char",buf_len); (*this).Oprint(); return NO;
            // I_file_plus<T>::Make_data_pack(char*)
    }
    sprintf(buf, "%*ld", digit, t_buf1);  // ν񤭹
    buf[digit] = '\0';
    for (i = 0; i <= vl; i++)  // ǡͤν񤭹
        buf[digit + 1 + i] = line_data[vh + i];
    buf[buf_len - 1] = '\0';

    // ǡѥåκȻǡͤ
    Data<T> *dp_buf = new Data<T>;
    if (dp_buf == NULL)
        { Eprint_memory(__FILE__,__LINE__,"Data<T>", YES); (*this).Oprint(); return NO; }
            // I_file_plus<T>::Make_data_pack(char*)

    char* memo = buf;
    dp_buf->Dstr2dpack(memo);  // Ѵ : ʸ ==> ǡѥå
        /*
        Dstr2dpack  memo ʸ˥եȤ
        buf ϤȥեȤ delete ʤʤäƤޤΤǡԡϤ
        */
    delete [] buf;
    dp = ((void*) dp_buf);
    return YES;
}


template <class T>
Boolean I_file_plus<T>::Set_time_unit(time_t t_unit)
{
    if (t_unit <= 0) { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
        // I_file_plus<T>::Set_time_unit(void)
        // Invalid setting : time_unit <= 0

    time_unit = t_unit; return YES;
}


template <class T>
Boolean I_file_plus<T>::Set_time_lag(double t_lag)
{
    t_lag *= ((double) time_unit);  // Ѵ

    if (Double2time_t(t_lag, time_lag) == NO)
        { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
            // I_file_plus<T>::Set_time_lag(void)
            // Setting of time_lag is out of time_t (long) range.

    return YES;
}


template <class T>
Boolean I_file_plus<T>::Init(char* f_name, int column,
                             time_t t_unit, double t_lag)
{
    if (I_file<T>::Init(f_name) == NO) return NO;

    if (column <= 0) { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
        // I_file_plus::Init(char*,time_t,int)
        // Invalid argument column <= 0
    (*this).object_number = column;

    if (Set_time_unit(t_unit) == NO || Set_time_lag(t_lag) == NO)
        { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
            // I_file_plus::Init(char*,time_t,int)
    return YES;
}


//  饹ƥץ졼 O_file_plus μ

template <class T>
void O_file_plus<T>::Cprint(FILE* fp_out, char* head)
{
    O_file<T>::Cprint(fp_out, head);
    fprintf(fp_out, "%s    time_unit=%ld,time_lag=%ld\n",
            head, time_unit, time_lag);
}


template <class T>
int O_file_plus<T>::Calculate_digit(void)
{
    double inv_time_unit = 1.0000000000000000 / ((double) time_unit);
    int digit = ((int) -log10(inv_time_unit)) + 3;

    inv_time_unit = 1.0000000000000000 / ((double) LONG_MAX);
    int digit_max = ((int) -log10(inv_time_unit)) + 3;

    return (digit <= digit_max) ? digit : digit_max;
}


template <class T>
void O_file_plus<T>::Output_data(void)
{
    void** dp_array; int num_of_dps;
    (*this).Get_data_pack_array(dp_array, num_of_dps);

    if (((Data_pack*) dp_array[num_of_dps - 1])->Data_time() <= (*this).last_data_time)
        return;
        /*
        ǡѥå̤Τᡢեס
        ޤϡǡϿ郎 LONG_MIN ǥե˽ϤƤʤǡ
        ѥåĤƤ롣
        ξ硢 LONG_MIN ʹߤΥǡȶ˽Ϥ롣
        ߥ졼γϤ LONG_MIN ξ硢λ LONG_MIN ˤʤ
        ΤǺǽŪˤ LONG_MIN ΥǡѥåϤ롣
        */

    int clm, clm_max;
    FILE* fp_src = fopen((*this).object_name, "r");
    FILE* fp_dest;
    int i;
    time_t t_buf; T v_buf; double t_buf_d;  // ѥХåե
    int digit = Calculate_digit();  // ǡϿﵭξʲ
    char no_data[4] = { '*','*','*','\0' };  // ¬ǡ˽񤭹ʸ

    if (fp_src == NULL) {    // ϥե򿷵
NEWFILE:
        Write_hedda();

        fp_dest = fopen((*this).object_name, "a");  // ϥեΥץ
        if (fp_dest == NULL) {
            Eprint_fopen(__FILE__,__LINE__,(*this).object_name,"a"); (*this).Oprint(); return;
                // O_file_plus<T>::Output_data(void)
        }

        for (i = 0; i < num_of_dps; i++) {   // ǡν
            ((Data<T>*) dp_array[i])->Get_data(t_buf, v_buf);
            t_buf_d = ((double) (((double) t_buf) / ((double) time_unit)));
            fprintf(fp_dest, "%.*f", digit, t_buf_d);
            for (clm = 1; clm < (*this).object_number; clm++)
                fprintf(fp_dest, " %s", no_data);
            fputc(' ', fp_dest); data2ofile(v_buf, fp_dest);
            fputc('\n', fp_dest);
        }
        fclose(fp_src); fclose(fp_dest);

    } else {  // ϥե뤬¸

        // ¸ϥեɤ߼ʸХåեκ
        int buffer; int c = 1, c_max = 1;
        while ((buffer = fgetc(fp_src)) != EOF) {
            // ¸ϥեĹ c_max ʴޤ \n\0ˤ
            c++;
            if (buffer == '\n') { c_max = (c_max > c) ? c_max : c; c = 1; }
        }
        if (c_max <= 0) { fclose(fp_src); goto NEWFILE; }  // 
        char* line_data = new char[c_max];
        if (line_data == NULL) {
            Eprint_memory(__FILE__,__LINE__,"char",(c_max + 1)); (*this).Oprint();
                // O_file_plus::Output_data(void)
                // For buffer string to read existing output_file
            fclose(fp_src); exit(5);
        }

        // ѥեΥץ
		// modified by Y.Ichikawa (Tue Feb 13 22:03:58 1996)
		// tmp_fname Υ᤮Τǡstdio.h 
		// Ƥ륵ѹ
        char tmp_fname[L_tmpnam];  // ϥեΰŪ̾

        if ((tmpnam(tmp_fname) == NULL) ||
			((fp_dest = fopen(tmp_fname, "w")) == NULL)) {
            Eprint(__FILE__,__LINE__); (*this).Oprint();
                // O_file_plus<T>::Output_data(void)
                // Cannot make temporary file for output.
           fclose(fp_src); delete [] line_data; line_data = NULL; return;
        }

        // ϥեν񤭹
        // ޤ tmp_fname ˽Ϥ夫 object_name ˥ԡ

        // ǡϿñ̤γǧ
        fseek(fp_src, 0, 0);  // fp_src եƬ᤹
        char* flag_src;

        while ((flag_src = fgets(line_data, c_max+1, fp_src)) != NULL) {
            if (line_data[0] != '#' || line_data[1] == '@') break;
            fprintf(fp_dest, "%s", line_data);
            if (line_data[1] == '*') {
                if (sscanf((line_data + 2), "%ld", &t_buf) != 1) continue;
                if (t_buf != time_unit) {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // O_file_plus<T>::Output_data(void)
                        // time_unit dose not match.
                    fclose(fp_src); fclose(fp_dest); exit(1);
                }
            }
            if (line_data[1] == '+') {
                if (sscanf((line_data + 2), "%lf", &t_buf_d) != 1) continue;
                if (Double2time_t(t_buf_d, t_buf) == NO
                    || t_buf != time_lag) {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // O_file_plus<T>::Output_data(void)
                        // time_lag dose not match.
                    fclose(fp_src); fclose(fp_dest); exit(1);
                }
            }
        }

        // إåν񤭹ߡֹ˥ǡ
        clm = 0; clm_max = (*this).object_number;

        // (object_number - 1) ΥإåΥԡ
        do {
            if (line_data[0] != '#') break;
            if (line_data[1] == '@') {
                if (sscanf((line_data + 2), "%d", &clm) != 1) continue;
                if (clm >= (*this).object_number) break;
            }
            fprintf(fp_dest, "%s", line_data);
        } while ((flag_src = fgets(line_data, c_max, fp_src)) != NULL);

        // object_number ܤΥإåν񤭹
        Write_output_info(fp_dest); Write_line(fp_dest);
        if (clm == (*this).object_number) {  // fp_src ʤ
            //  while 롼פ fgets == NULL or line_data[0] != '#' 
            // ȴ硢clm < object_numberfp_src ϿʤǤʤ
            while ((flag_src = fgets(line_data, c_max, fp_src)) != NULL)
                if (line_data[0] != '#' || line_data[1] == '@') break;
        }

        // (object_number + 1) ʹߤΥإåΥԡ
        if (flag_src != NULL) {
            do {    // ֥إåΥԡ
                if (line_data[0] != '#') break;
                if (line_data[1] == '@') {
                    if (sscanf((line_data + 2), "%d", &clm) != 1) continue;
                    clm_max = (clm > clm_max) ? clm : clm_max;
                }
                fprintf(fp_dest, "%s", line_data);
            } while ((flag_src = fgets(line_data, c_max, fp_src)) != NULL);
        }

        // ǡͤν񤭹
        time_t t_src;

        if (flag_src == NULL) {
            for (i = 0; i < num_of_dps; i++) {   // ǡν
                ((Data<T>*) dp_array[i])->Get_data(t_buf, v_buf);
                t_buf_d = ((double) t_buf);
                t_buf_d /= ((double) time_unit);
                fprintf(fp_dest, "%.*f", digit, t_buf_d);
                for (clm = 1; clm < (*this).object_number; clm++)
                    fprintf(fp_dest, " %s", no_data);
                fputc(' ', fp_dest); data2ofile(v_buf, fp_dest); clm++;
                for (; clm <= clm_max; clm++) fprintf(fp_dest, " %s", no_data);
                fprintf(fp_dest, "\n");
            }
            goto TMP_MADE;
        }

        for (i = 0; i < num_of_dps; i++) {
            // 񤭹ǡμ
            ((Data<T>*)dp_array[i])->Get_data(t_buf, v_buf);

            if (flag_src == NULL) {
                t_buf_d = ((double) t_buf);
                t_buf_d /= ((double) time_unit);
                fprintf(fp_dest, "%.*f", digit, t_buf_d);
                for (clm = 1; clm < (*this).object_number; clm++)
                    fprintf(fp_dest, " %s", no_data);
                fputc(' ', fp_dest); data2ofile(v_buf, fp_dest); clm++;
                for (; clm <= clm_max; clm++) fprintf(fp_dest, " %s", no_data);
                fprintf(fp_dest, "\n");
                continue;
            }

            do {
                if (line_data[0] == '#')  // ȹ
                    { fprintf(fp_dest, "%s", line_data); continue; }
                for (c = 0; c < c_max; c++) {   // ƬΥԡ
                     if (line_data[c] != ' ' && line_data[c] != '\t') break;
                     fputc(line_data[c], fp_dest);
                }
                if (line_data[c] == '\n' || line_data[c] == '\0')  // 
                    { fputc('\n', fp_dest); continue; }

                // ǡ
                // ǡϿѴ
                sscanf(line_data, "%lf", &t_buf_d);
                t_buf_d *= ((double) time_unit);
                if (Double2time_t(t_buf_d, t_src) == NO) {
                    Eprint(__FILE__,__LINE__); (*this).Oprint();
                        // O_file_plus<T>::Output_data(void)
                        // Check data time of input file.
                    fclose(fp_src); fclose(fp_dest); exit(1);
                }

                // c ϥǡϿʸƬؤƤ

                if (t_src < t_buf) {  // t_buf Υǡ
                    for (clm = 0; clm <= clm_max; clm++) {
                        if (line_data[c] != '\'' && line_data[c] != '\"') {
                            for (; c < c_max; c++) {
                                if (line_data[c] == ' '
                                    || line_data[c] == '\t'
                                    || line_data[c] == '\n'
                                    || line_data[c] == '\0') break;
                                fputc(line_data[c], fp_dest);
                            }
                        } else {  // ʸǡ
                            char c_tmp = line_data[c];
                            fputc(line_data[c], fp_dest); c++;
                            for (; c < c_max; c++) {
                                if (line_data[c] == '\n'
                                    || line_data[c] == '\0')
                                    { fputc(c_tmp, fp_dest); break; }
                                fputc(line_data[c], fp_dest);
                                if (line_data[c] == c_tmp) { c++; break; }
                            }
                        }
                        for (; c < c_max; c++) {  // Υԡ
                            if (line_data[c] != ' ' && line_data[c] != '\t')
                                break;
                            fputc(line_data[c], fp_dest);
                        }
                    }
                    for (; clm <= clm_max; clm++)
                        fprintf(fp_dest, " %s", no_data);
                        // clm  clm_max ¬Ȥƽ񤭹
                    fputc('\n', fp_dest);  // fp_dest 򼡹Ԥ
                    // fp_src 򼡹Ԥؿʤᡢ񤭹ǡѥåϤΤޤ
                } else if (t_src == t_buf) {    // t_buf ˤǡ
                    // 0  object_number - 1 ޤǤΥǡʸ򥳥ԡ
                    for (clm = 0; clm < (*this).object_number; clm++) {
                        if (line_data[c] != '\'' && line_data[c] != '\"') {
                            for (; c < c_max; c++) {
                                if (line_data[c] == ' '
                                    || line_data[c] == '\t'
                                    || line_data[c] == '\n'
                                    || line_data[c] == '\0') break;
                                fputc(line_data[c], fp_dest);
                            }
                        } else {  // ʸǡ
                            char c_tmp = line_data[c];
                            fputc(line_data[c], fp_dest); c++;
                            for (; c < c_max; c++) {
                                if (line_data[c] == '\n'
                                    || line_data[c] == '\0')
                                    { fputc(c_tmp, fp_dest); break; }
                                fputc(line_data[c], fp_dest);
                                if (line_data[c] == c_tmp) { c++; break; }
                            }
                        }
                        if (line_data[c] == '\n' || line_data[c] == '\0') {
                            // object_number ̤ʬη¬
                            // ڤʸ ' ' ε
                            clm++;
                            for (; clm < (*this).object_number; clm++)
                                fprintf(fp_dest, " %s", no_data);
                            fputc(' ', fp_dest); break;
                        }
                        for (; c < c_max; c++) {  // Υԡ
                            if (line_data[c] != ' ' && line_data[c] != '\t')
                                break;
                            fputc(line_data[c], fp_dest);
                        }
                    }

                    // object_number ν񤭹
                    data2ofile(v_buf, fp_dest); clm++;

                    // object_number + 1 ܤƬ c ư
                    if (line_data[c] == '\'' || line_data[c] == '\"') {
                        // ʸǡ
                        char c_tmp = line_data[c];
                        c++;
                        for (; c < c_max; c++) {
                            if (line_data[c] == '\n' || line_data[c] == '\0')
                                break;
                            if (line_data[c] == c_tmp) { c++; break; }
                        }
                    } else {  // ͥǡ
                        for (; c < c_max; c++)
                            if (line_data[c] == '\n' || line_data[c] == '\0'
                                || line_data[c] == ' ' || line_data[c] == '\t')
                                break;
                    }
                    for (; c < c_max; c++)  // 
                        if (line_data[c] != ' ' && line_data[c] != '\t') break;

                    // object_number + 1  clm_max ν񤭹
                    for (; clm <= clm_max; clm++) {
                        if (line_data[c] != '\'' && line_data[c] != '\"') {
                            for (; c < c_max; c++) {
                                if (line_data[c] == ' '
                                    || line_data[c] == '\t'
                                    || line_data[c] == '\n'
                                    || line_data[c] == '\0') break;
                                fputc(line_data[c], fp_dest);
                            }
                        } else {  // ʸǡ
                            char c_tmp = line_data[c];
                            fputc(line_data[c], fp_dest); c++;
                            for (; c < c_max; c++) {
                                if (line_data[c] == '\n'
                                    || line_data[c] == '\0')
                                    { fputc(c_tmp, fp_dest); break; }
                                fputc(line_data[c], fp_dest);
                                if (line_data[c] == c_tmp) { c++; break; }
                            }
                        }
                        if (line_data[c] == '\n' || line_data[c] == '\0') {
                            // object_number ̤ʬη¬
                            clm++;
                            for (; clm < (*this).object_number; clm++)
                                fprintf(fp_dest, " %s", no_data);
                            break;
                        }
                        for (; c < c_max; c++) {  // Υԡ
                            if (line_data[c] != ' ' && line_data[c] != '\t')
                                break;
                            fputc(line_data[c], fp_dest);
                        }
                    }
                    fputc('\n', fp_dest);  // fp_dest 򼡹Ԥ
                    flag_src = fgets(line_data, c_max, fp_src); break;
                    // fp_src 򼡹ԤؿʤᡢΥǡѥå
                } else {    // (t_src > t_buf) 郎פԤʤ
                    t_buf_d = ((double) t_buf);
                    t_buf_d /= ((double) time_unit);
                    fprintf(fp_dest, "%.*f", digit, t_buf_d);
                    for (clm = 1; clm < (*this).object_number; clm++)
                        fprintf(fp_dest, " %s", no_data);
                    fputc(' ', fp_dest); data2ofile(v_buf, fp_dest); clm++;
                    for (; clm <= clm_max; clm++)
                        fprintf(fp_dest, " %s", no_data);
                    fputc('\n', fp_dest);  // fp_dest 򼡹Ԥ
                    break;
                    // fp_src ϤΤޤޤǡΥǡѥå
                }
            } while ((flag_src = fgets(line_data, c_max, fp_src)) != NULL);
        }

        if (flag_src == NULL) goto TMP_MADE;

        do {
            if (line_data[0] == '#')    // ȹ
                { fprintf(fp_dest, "%s", line_data); continue; }
            for (c = 0; c < c_max; c++)    // 
                 if (line_data[c] != ' ' && line_data[c] != '\t') break;
            if (line_data[c] == '\n' || line_data[c] == '\0')    // 
                { fprintf(fp_dest, "%s", line_data); continue; }

            for (c = clm = 0; clm <= clm_max; clm++) {
                for (; c < c_max; c++) {  // Υԡ
                    if (line_data[c] != ' ' && line_data[c] != '\t')
                        break;
                    fputc(line_data[c], fp_dest);
                }
                if (line_data[c] == '\n' || line_data[c] == '\0') break;
                if (line_data[c] != '\"' && line_data[c] != '\'') {  // 
                    for (; c < c_max; c++) {
                        if (line_data[c] == '\n' || line_data[c] == '\0')
                            { fputc(' ', fp_dest); break; }
                        if (line_data[c] == ' ' || line_data[c] == '\t') break;
                        fputc(line_data[c], fp_dest);
                    }
                } else {  // ʸ
                    char c_tmp = line_data[c];
                    fputc(line_data[c], fp_dest); c++;
                    for (; c < c_max; c++) {
                        if (line_data[c] == '\n' || line_data[c] == '\0')
                            { fputc(c_tmp, fp_dest); break; }
                        fputc(line_data[c], fp_dest);
                        if (line_data[c] == c_tmp) { c++; break; }
                    }
                }
            }
            for (; clm <= clm_max; clm++) fprintf(fp_dest, " %s", no_data);
            fputc('\n', fp_dest);
        } while ((flag_src = fgets(line_data, c_max, fp_src)) != NULL);

TMP_MADE:
        delete [] line_data; line_data = NULL;
        fclose(fp_src); fclose(fp_dest);

        // ԡ
        if ((fp_src = fopen(tmp_fname, "r")) == NULL) {
            Eprint_fopen(__FILE__,__LINE__,tmp_fname,"r"); (*this).Oprint(); return;
                // O_file_plus<T>::Output_data(void)
        }
        if ((fp_dest = fopen((*this).object_name, "w")) == NULL) {
            Eprint_fopen(__FILE__,__LINE__,(*this).object_name,"w"); (*this).Oprint();
                // O_file_plus<T>::Output_data(void)
            fclose(fp_src); return;
        }
        while ((c = fgetc(fp_src)) != EOF) fputc(c, fp_dest);
        fclose(fp_src); fclose(fp_dest);
        remove(tmp_fname);
    }

    (*this).last_data_time = ((Data_pack*) dp_array[num_of_dps - 1])->Data_time();
    (*this).Reduce_data_pack_stock();
    return;
}


template <class T>
Boolean O_file_plus<T>::Write_hedda(void)
{
    FILE* fp = fopen((*this).object_name, "w");    // ϥե񤭹
    if (fp == NULL) {
        Eprint_fopen(__FILE__,__LINE__,(*this).object_name,"w"); (*this).Oprint();
            // O_file_plus<T>::Write_hedda_new(void)
        return NO;
    }

    // ե̾time_unittime_lag ε
    fprintf(fp, "# %s\n", (*this).object_name);
    Write_line(fp);
    int digit = Calculate_digit();  // time_lag ξʲ
    double t_buf_d = ((double) time_lag) * ((double) time_unit);
    fprintf(fp, "#* %ld\n#+ %.*f\n", time_unit, digit, t_buf_d);
    Write_line(fp);
    Write_output_info(fp);  // ϥǡ
    Write_line(fp);
    fprintf(fp, "\n\n");

    fclose(fp); return YES;
}


template <class T>
void O_file_plus<T>::Write_line(FILE* fp)
{
    fputc('#', fp); fputc(' ', fp);
    for (int k = 0; k < 70; k++) fputc('-', fp);
    fputc('\n', fp);
}


template <class T>
void O_file_plus<T>::Write_output_info(FILE* fp)
{
    fprintf(fp, "#@ %d\n", (*this).object_number);  // ǡֹ

    // 񤭹߻ε
    time_t t0; tm* t1;
    time(&t0);
    t1 = localtime(&t0);
    fprintf(fp, "# %s", asctime(t1));

    (*this).Oprint(fp, "#   ");
}


template <class T>
Boolean O_file_plus<T>::Set_time_unit(time_t t_unit)
{
    if (t_unit <= 0) { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
        // O_file_plus<T>::Set_time_unit(void)
        // Invalid setting : time_unit <= 0

    time_unit = t_unit; return YES;
}


template <class T>
Boolean O_file_plus<T>::Set_time_lag(double t_lag)
{
    t_lag *= ((double) time_unit);  // Ѵ

    if (Double2time_t(t_lag, time_lag) == NO)
        { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
            // O_file_plus<T>::Set_time_lag(void)
            // Setting of time_lag is out of time_t (long) range.

    return YES;
}


template <class T>
Boolean O_file_plus<T>::Init(char* f_name, int column,
                             time_t t_unit, double t_lag)
{
    if (O_file<T>::Init(f_name) == NO) return NO;

    if (column <= 0) { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
        // O_file_plus::Init(char*,time_t,int)
        // Invalid argument column <= 0
    (*this).object_number = column;

    if (Set_time_unit(t_unit) == NO || Set_time_lag(t_lag) == NO)
        { Eprint(__FILE__,__LINE__); (*this).Oprint(); return NO; }
            // O_file_plus::Init(char*,time_t,int)
    return YES;
}


// added by Y.Ichikawa (Wed Feb 14 21:38:50 1996)
// -------------------------------------------------------------
// instantiation
// -------------------------------------------------------------

template class I_file_plus<double>;
template class O_file_plus<double>;
template class I_file_plus<float>;
template class O_file_plus<float>;
template class I_file_plus<int>;
template class O_file_plus<int>;
template class I_file_plus<long>;
template class O_file_plus<long>;
template class I_file_plus<OHyMosString>;
template class O_file_plus<OHyMosString>;

typedef Vary<int> Viary;
typedef Vary<long> Vlary;
typedef Vary<float> Vfary;
typedef Vary<double> Vdary;
template class I_file_plus<Viary>;
template class O_file_plus<Viary>;
template class I_file_plus<Vlary>;
template class O_file_plus<Vlary>;
template class I_file_plus<Vfary>;
template class O_file_plus<Vfary>;
template class I_file_plus<Vdary>;
template class O_file_plus<Vdary>;


#endif    // if ! io_file_plus_cc


// end of file
