/*;  mbar.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl mbar.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:53:44 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/mbar.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  bar graph

/* <japanese>

ޤդηǡ򡤰ֳִʿͤΥǡ
ѴüҤ˽ϤեǥפΥإåեǤ

\begin{description}
\item[饹̾] MakeBar

\item[ǥ̾] եǥ

\item[ǽ] ޤդηǡ򡤻ֳִ $\Delta t$
δ֤ʿͤΥǡѴüҤ˽Ϥޤֳִ $\Delta t$
ưŪѹ뤳ȤǤޤϤ $y(t)$ ȤȤ

\[  {1 \over \Delta t} \int_t^{t + \Delta t} y(s) ds \]

 $t + \Delta t$ νͤȤޤ

\item[üҤλ] üҤϣĤǤüҤ갷ǡѥå
ϡ\verb|Data<double>| Ǥǡλֳִ֤ƱǤʤƤ⹽


\item[üҤλ] üҤϣĤǤǡϡ
\verb|Data<double>| Ǥֳִ $\Delta t$ ѹʤСλ
ֳִ֤ΥǡޤϥǡѥåΥǡͤϡ˽Ϥ
ǡѥåΥǡϿ狼餽ΥǡѥåΥǡޤǤδ֤
ǡʿͤǤĤνϥǡѥåϥǡϿ
̣ꡤǡͤˤϰ̣Ϥޤ󡣣Ĥνϥǡѥå
Υǡͤˤϡ(ͥե뤫ɤߤȤäꤷ) λνִ
ǼƤޤ

ϥǡѥåΥǡͤμϡǡѥåΥǡͤμƱ
Ǥ

\item[ѥ᥿] ʿѤȤֳִ $\Delta t$. ǽϡֳִ $\Delta
t$ ϡѥ᥿ե뤫ɤߤȤäƷꤷޤ
\verb|Set_parameter(int dt)| ؿȤäơưŪˡ
ֳִ $\Delta t$ ͤѹ뤳ȤǤ
ޤޤDuration ؿȤäơ$\Delta t$ ͤΤ뤳ȤǤޤ

\item[] ̤ϡ\verb|current_time| Ǥ

\end{description}

<japanese> */


/* mbar.h		饹 MakeBar Υإåե
-----------------------------------------------------------------------
	MakeBar : եǥ
------------------------------------------------------------------------
*/

#if !defined(_mbar_h)
#define _mbar_h

#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>

#include <time.h>

#include "common.h"                                 /* ̴Ķ */
#include "list.h"                               /* 饹 List  */
#include "element.h"                         /* 饹 Element  */
#include "p_tmp.h"         /* ƥץ졼ȥ饹 Receive, Send  */


class MakeBar : public Element {

/* ѥ᥿ */

  protected:
	int dt;                                 // ʿѲֳִ $\Delta t$

/*  */

	// äˤʤΤߡ

/* üҡü */

  protected:
	Receive<double> rp;
	// ֥̾ rp, ֹ֥ 0

	Send<double> sp;
	// ֥̾ sp, ֹ֥ 0

  protected:
	void Register_receive_ports(void) { Register((void*) &rp); }
	void Register_send_ports(void) { Register((void*) &sp); }

/* ѿ */

  protected:
	double y;	                      // current_time Υǡ. 

/* ؿ󥹥ȥ饯ǥȥ饯 */

  private:
	// ػߤ뤿ޤ
	MakeBar& operator=(const MakeBar& rhs);

  public:
	Boolean Init(char* o_name, int o_num, char* p_str = NULL)
		{ return Element::Init(o_name, o_num, 0, p_str); }
	MakeBar(char* o_name, int o_num, char* p_str = NULL)
		: Element(), dt(1), rp("rp", 0), sp("sp", 0), y(0)
 		{ class_name = "MakeBar"; Init(o_name, o_num, p_str); }
	MakeBar(void)
		: Element(), dt(1), rp("rp", 0), sp("sp", 0), y(0)
		{ class_name = "MakeBar"; }

	~MakeBar(void) {}

/* ѥ᡼ꡦ̤ν */

  public:
	void Set_parameter(FILE* fp);
	// ѥ᡼ dt  fscanf(fp, "%d", &dt) ɤߤȤޤ
	// dt ͤǤʤХ顼å񤤤ߤޤ

	void Set_parameter(int dt);
	// ѥ᡼ dt ľܻꤷޤ
	// dt ͤǤʤХ顼å񤤤ߤޤ

	void Set_initial_state(FILE* fp);
	//  current_time  fscanf(fp, "%ld",&current_time)
	// ɤߤȤäͤѹޤɤߤȤäͤʤѹޤ

	void Set_initial_state(time_t ct);
	//  current_time ľ ct ѹޤct ʤѹ
	// ޤ

	void Save_terminal_state(FILE* fp)
	{ if (fp != NULL) fprintf(fp, "%ld", current_time); }

	// MakeBar ͭΥдؿ
	int Duration(void) { return dt; }

/* ׻ǽ */

  public:
	Boolean Initial_output(void) {
		if (rp.Can_you_get_data(current_time, current_time) == NO)
		    return NO;
		y = rp.Get_data(current_time);
		sp.Send_data(current_time, y);
		return YES;
	}
	time_t Calculate_time_step(void) { return dt; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
	// Can_you_calculate0  Next_time() ޤǤΥǡ׵

	Boolean Work(void) { return Work0(); }
	Boolean Calculate(void);

};

#endif

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Revision: 1.7 ѹ
hymoshist.doc 110 ˽񤤤ѹбޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */


/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
