/*;  mempool.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl mempool.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:53:56 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/mempool.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) pool of memory

#ifndef mempool_h
#define mempool_h

#include <stdlib.h>

template < class T >
class MemoryPool {
public:
  MemoryPool(size_t size = EXPANSION_SIZE);
  ~MemoryPool();

  //; ꥹȤTǤݤ롣
  inline void* alloc(size_t size);

  //; TǤꥹȤ֤
  inline void free(void *someElement);

private:
  //; ꥹȤΤĤ
  MemoryPool<T> *next;

  //; ꥹȤξϡ̤礹롣
  enum { EXPANSION_SIZE = 64 };

  //; ե꡼ǤꥹȤɲä롣
  void expandTheFreeList(int howMany = EXPANSION_SIZE);
};

template < class T >
MemoryPool < T >::MemoryPool(size_t size)
{
  expandTheFreeList(size);
}

template < class T >
inline
void* MemoryPool < T >::alloc(size_t)
{
  if (!next) {
    expandTheFreeList();
  }
  MemoryPool<T> *head = next;
  next = head->next;
  return head;
}

template < class T >
inline
void MemoryPool < T >::free(void *doomed)
{
  MemoryPool<T> *head = (MemoryPool<T> *)doomed;
  head->next = next;
  next = head;
}

#endif // mempool_h


/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
