/*;  ohoption.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl ohoption.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:55:53 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/ohoption.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  OHyMoS option variables

#if !defined(_ohoption_h)
#define _ohoption_h

/*----------------------------------------------------------------
CLASS

    OhymosOption

    OhymosOption treats specification of general options for simulation.

KEYWORDS

    option

DESCRIPTION
    OhymosOption treats specification of general options for simulation.

    Simulation options are specified by the values of the data members
    of this class.  Default options are specified in object.cc.

    Member functions of Total_system can change the simulation options,
    because the class Total_system is a friend of this class.

    keywords: option

----------------------------------------------------------------*/

class OhymosOption {
	/* <japanese>
	    OhymosOption	OHyMoS ˤ륷ߥ졼ΤΥץ

	  OHyMoS ˤ륷ߥ졼Τ˴ؤ륪ץλ갷
	  ޤ

	  ץϡΥ饹ΥǡСͤǻꤷޤ

	  ǥեȤΥץϡobject.cc ǻꤷƤޤ

	  ץѹǤΤϡTotal_system ΥдؿǤ
	  饹 Total_system ϡΥ饹 friend Ǥ

 	<japanese> */
public:
  //////////////////////////////////////////////////////////////////////
  // Definition of enum TimeControl
  // [] GoBeyondTerminalTime: Can go beyond the teminal time
  // [] DoNotGoBeyondTerminalTime: Cannot go beyond the terminal time
  enum TimeControl { GoBeyondTerminalTime, DoNotGoBeyondTerminalTime };

private:
  //////////////////////////////////////////////////////////////////////
  // Option about time control
  static TimeControl tc;

public:
  //////////////////////////////////////////////////////////////////////
  // Returns the time control option
  static TimeControl Get_time_control_option(void);

  friend class Total_system;
};

#endif

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
