/* ostring.cc {\documentstyle{jsrc2latex}\rhead{\sl ostring.cc\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile: ostring.cc,v $  $Revision: 1.1 $
$Date: 2000/12/02 10:07:24 $  by KyotoHydro
\end{verbatim}}

{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <string.h>
#include "ostring.h"
#include <assert.h>
#include <ctype.h>

OHyMosString::OHyMosString(void) {	s = new char[1];  *s = 0; }

OHyMosString::OHyMosString(const char* x)
{ s = new char[strlen(x)+1]; strcpy(s,x); }

OHyMosString::OHyMosString(const OHyMosString& x)
{ s = new char[strlen(x.s)+1]; strcpy(s,x.s); }

OHyMosString& OHyMosString::operator=(const char* x)
{
	delete [] s;
	s = new char[strlen(x) + 1];
	strcpy(s, x);
	return (*this);
}

OHyMosString& OHyMosString::operator=(const OHyMosString& x)
{
	delete [] s;
	s = new char[strlen(x.s) + 1];
	strcpy(s, x.s);
	return (*this);
}

char& OHyMosString::operator[](size_t i) { return (s[i]); }

OHyMosString::operator char*()
{
	char* p = new char[strlen(s) + 1];
	strcpy(p, s);
	return p;
}

void
OHyMosString::operator +=(const OHyMosString& str)
{
  char* p = new char[strlen(s) + strlen(str.s) + 1];
  strcpy(p, s);
  strcat(p, str.s);
  delete [] s;
  s = new char[strlen(p) + 1];
  strcpy(s, p);
  delete [] p;
}

void
OHyMosString::operator +=(char* cstr)
{
  char* p = new char[strlen(s) + strlen(cstr) + 1];
  strcpy(p, s);
  strcat(p, cstr);
  delete [] s;
  s = new char[strlen(p) + 1];
  strcpy(s, p);
  delete [] p;
}

void
OHyMosString::operator +=(const char c)
{
  int n = strlen(s);
  char* p = new char[n + 2];
  strcpy(p, s);
  p[n] = c;
  p[n+1] = '\0';
  delete [] s;
  s = new char[strlen(p) + 1];
  strcpy(s, p);
  delete [] p;
}

istream & operator >> (istream & strm, OHyMosString & str)
{
  static const size_t bufsize = 256;
  static char buf[bufsize];

  if (!strm) {
    buf[0] = '\0';
    str = buf;
    return strm;
  }

  size_t ipos = 0;
  char c;

  while (strm.get(c)) {
    if (!isspace(c)) break;
  }
  if (strm.eof()) {
    buf[0] = '\0';
    str = buf;
    return strm;
  }
  if (c == '\'' || c == '\"') {
    char cmt = c;
    while (strm.get(c)) {
      if (c == cmt) break;
      if (ipos > bufsize - 1) {
	    abort();
      }
      buf[ipos++] = c;
    }
    assert(c == cmt);
    buf[ipos] = '\0';
  }
  else {
    buf[ipos++] = c;
    while (strm.get(c)) {
      if (isspace(c)) break;
      if (ipos > bufsize - 1) {
        abort();
      }
      buf[ipos++] = c;
    }
    if (isspace(c)) {
      strm.putback(c);
    }
    else {
      strm.clear();
    }
    buf[ipos] = '\0';
  }

  str = buf;
  return strm;
}

// *********************************************************************

void dstr2data(char*& dstr, OHyMosString& a) { a = dstr; }

void data2file(OHyMosString& a, FILE* fp) { fprintf(fp, "(%s)\n", (char*)a); }

// void data2ofile(OHyMosString& a, FILE* fo) { fprintf(fo, " %s", (char*)a); }

// modified by Suzuki,T (Sat Feb 10 15:54:40 1996)
void data2ofile(OHyMosString& a, FILE* fo) { fprintf(fo, "\"%s\"", (char*)a); }

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
