; @(#) mycctips.el
;
; $RCSfile: mycctips.el,v $  $Revision: 1.1 $
; $Date: 2000/01/17 21:59:09 $  by KyotoHydro
; $RCShost: tone.kuciv.kyoto-u.ac.jp $

(defun kh-equationblock ()
  "Prepare a src2latex equation block"
  (interactive)
  (let ((cp (current-column)) a)
        (setq a (+ (/ cp 2) 1))
        (insert "/* {\\ {\\setlength{\\parskip}{4pt}\\begin{indentation}{")
        (insert (format "%d" a))
        (insert "em}{0em}\n")
        (insert-char 32 cp)
        (insert "\n");
        (insert-char 32 cp)
        (insert "\\end{indentation}}% end of latex-mode }\n")
        (insert-char 32 cp)
        (insert "*/\n")
        (previous-line 3)
        (end-of-line))
  )

(defun kh-cocoonsentinel ()
  "Insert a cocoon sentinel string"
  (interactive)
  (let ((nc (- fill-column comment-column)))
    (beginning-of-line)
    (insert-char 32 comment-column)
    (insert-char ?/ nc)
    (insert "\n")
    ))

(defun kh-printdata (beg end)
  (interactive "r")
  (let (variable)
    (setq variable (buffer-substring beg end))
    (other-window 1)
    (insert "p " variable)
    (comint-send-input)
    (other-window 1)
    ))

; gdb ΥɽѥХåեǻѤؿC++ ѿξ˥
; ֤Ƥδؿ¹Ԥȡѿͤɽ̿ gdbХ
; եǼ¹Ԥ롣ޤʣʵˡѤ C++ ѿˤбǤ
; ʤ㤨Сa->b ʤɤˤбǤʤ
;
(defun kh-pdata ()
  (interactive)
  (let (variable beg end)
    (skip-chars-backward ".a-zA-Z_0-9[")
    (setq beg (point))
    (skip-chars-forward ".a-zA-Z_0-9")
    (while (= (char-after (point)) ?\[)
        (progn
          (skip-chars-forward "^]")
          (skip-chars-forward "]")))
    (setq end (point))
    (setq variable (buffer-substring beg end))
    (other-window 1)
    (insert "p " variable)
    (comint-send-input)
    (other-window 1)
    ))

(defun kh-adjust-cocoon-lines ()
  "cocoon sentinel line Ĺ fill-column ˤʤ褦Ĵޤ
ХåեΤоݤǤˡ10İʾ / = Ԥϡ
cocoon sentinel line ޤ"
  (interactive)
  (let (lastline cline b e c ovly)
    (goto-char (point-max))
    (setq lastline (count-lines 1 (point)))
    (goto-char (point-min))
    (setq cline 0)
    (while (< cline lastline)
      (beginning-of-line)
      (setq b (point))
      (end-of-line)
      (setq e (point))
      (setq c ?a)
      (if (string-match "//////////$" (buffer-substring b e))
          (setq c ?/))
      (if (not (= c ?a))
          (if (not (= (current-column) fill-column))
              (progn
                (setq ovly (make-overlay b e))
                (overlay-put ovly 'face 'highlight)
                (insert " <==")
                (setq ans (y-or-n-p
                           "Adjust this line? "))
                (end-of-line)
                (backward-delete-char-untabify 4)
                (if ans
                    (progn
                      (if (< (current-column) fill-column)
                          (while (< (current-column) fill-column)
                            (insert c))
                        (while (> (current-column) fill-column)
			  (backward-delete-char-untabify 1)))))
                (delete-overlay ovly)
                )))
      (setq cline (+ cline 1))
      (next-line 1))
    (message "finished kh-adjust-cocoon-lines")
    ))
