/*;  sub.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl sub.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:12:16 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/sub.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  sub.cc -- implementation of class Sub_system

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>		//; time_t , tm 
#include <limits.h>		//; LONG_MAX 
#include <stdarg.h>		//; ĹŸޥ

#include "common.h"		//; ̴Ķʤɤ
#include "list.h"		//; 饹 List 
#include "port.h"		//; 饹 Port 
#include "element.h"	//; 饹 Element 
#include "sub.h"		//; 饹 Sub_system 
#include "sender.h"		// definition of class sender_port

//;	饹 Sub_system Υдؿμ

Boolean Sub_system::Connect(
			void* my_p,
			void* r, char* rp_c_name, char* rp_name, int rp_num)
{	//;		Sub_system::Connect(void*,void*,char*,char*,int) (define)

	//; ֥ȤμüҤ.
	void* rp = ((Element*) r)
				->Get_receive_port(rp_c_name, rp_name, rp_num);
	if (rp == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,void*,char*,char*,int)
		// Cannot connect ports. Cannot get 'receive_port' to connect.

	return ((((Port*) rp)->Set_sender(my_p) == YES)
			&& (((Port*) my_p)->Register_receiver(rp) == YES))
			? YES : NO;
}


Boolean Sub_system::Connect(
			void* s, char* sp_c_name, char* sp_name, int sp_num,
			void* r, char* rp_c_name, char* rp_name, int rp_num)
{	//;		Sub_system::Connect(void*,char*,char*,int,
	//;							void*,char*,char*,int) (define)

	//; ֥Ȥü, üҤ.
	void* sp = ((Element*) s)->Get_send_port(sp_c_name, sp_name, sp_num);
	if (sp == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,char*,int,void*,char*,char*,int)
		// Cannot connect ports.
		// Cannot get 'send_port' to connect.

	void* rp = ((Element*) r)
				->Get_receive_port(rp_c_name, rp_name, rp_num);
	if (rp == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,char*,int,void*,char*,char*,int)
		// Cannot connect ports.
		// Cannot get 'receive_port' to connect.

	return ((((Port*) rp)->Set_sender(sp) == YES)
			&& (((Port*) sp)->Register_receiver(rp) == YES))
			? YES : NO;
}


Boolean Sub_system::Connect(
			void* s, char* sp_c_name, char* sp_name, int sp_num,
			void* my_p)
{	//;		Sub_system::Connect(void*,char*,char*,int,void*) (define)

	//; ³üҤ.
	void* sp = ((Element*) s)->Get_send_port(sp_c_name, sp_name, sp_num);
	if (sp == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,char*,int,void*)
		// Cannot connect ports. Cannot get 'send_port' to connect.

	return ((((Port*) my_p)->Set_sender(sp) == YES)
			&& (((Port*) sp)->Register_receiver(my_p) == YES))
			? YES : NO;
}

//; 饹̾Υåά Connect

Boolean Sub_system::Connect(
			void* my_p,
			void* r, char* rp_name, int rp_num)
{	//;		Sub_system::Connect(void*,void*,char*,int) (define)

	//; ֥ȤμüҤ.
	void* rp = ((Element*) r)
				->Get_receive_port(rp_name, rp_num);
	if (rp == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,void*,char*,int)
		// Cannot connect ports. Cannot get 'receive_port' to connect.

	return ((((Port*) rp)->Set_sender(my_p) == YES)
			&& (((Port*) my_p)->Register_receiver(rp) == YES))
			? YES : NO;
}


Boolean Sub_system::Connect(
			void* s, char* sp_name, int sp_num,
			void* r, char* rp_name, int rp_num)
{	//;		Sub_system::Connect(void*,char*,int,
	//;							void*,char*,int) (define)

	//; ֥Ȥü, üҤ.
	void* sp = ((Element*) s)->Get_send_port(sp_name, sp_num);
	if (sp == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,int,void*,char*,int)
		// Cannot connect ports.
		// Cannot get 'send_port' to connect.

	void* rp = ((Element*) r)
				->Get_receive_port(rp_name, rp_num);
	if (rp == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,int,void*,char*,int)
		// Cannot connect ports.
		// Cannot get 'receive_port' to connect.

	return ((((Port*) rp)->Set_sender(sp) == YES)
			&& (((Port*) sp)->Register_receiver(rp) == YES))
			? YES : NO;
}


Boolean Sub_system::Connect(
			void* s, char* sp_name, int sp_num,
			void* my_p)
{	//;		Sub_system::Connect(void*,char*,int,void*) (define)

	//; ³üҤ.
	void* sp = ((Element*) s)->Get_send_port(sp_name, sp_num);
	if (sp == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Connect(void*,char*,int,void*)
		// Cannot connect ports. Cannot get 'send_port' to connect.

	return ((((Port*) my_p)->Set_sender(sp) == YES)
			&& (((Port*) sp)->Register_receiver(my_p) == YES))
			? YES : NO;
}

Boolean Sub_system::Connect(void* my_sp, void* my_rp)
{
     return ((((Port*) my_rp)->Set_sender(my_sp) == YES)
           && (((Port*) my_sp)->Register_receiver(my_rp) == YES))
           ? YES : NO;
}


// added by Y.Ichikawa (Sat Nov 11 15:14:13 1995)
void Sub_system::Initialize_iterator_array(void)
{
	if ((iterator_array = new void**[number_of_iterator_sets]) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Sub_system::Initialize_iterator_array
			// Cannot get memory for "iterator_array".

	if ((number_of_iterators = new int[number_of_iterator_sets]) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Sub_system::Initialize_iterator_array
			// Cannot get memory for "number_of_iterators".

	int i;
	for (i = 0; i < number_of_iterator_sets; i++) {
		iterator_array[i] = NULL;
		number_of_iterators[i] = -1;
		//; Make_object_array ϤȤǤʤȤϤͤ.
	}
}


// added by Y.Ichikawa (Sat Nov 11 15:13:47 1995)
Boolean Sub_system::Register(int num,...)
{
	//; iterator_array[i] == NULL ȤʤäƤ i õ. ʤä exit
	int i; Boolean flag = NO;
	for (i = 0; i < number_of_iterator_sets; i++) {
		if (iterator_array[i] == NULL) {
			flag = YES;
			break;
		}
	}
	if (flag == NO)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Register(void*,...)
			// iterator_array is already full.
			// Please check "number_of_iterator_sets".

	va_list ap;
	va_start(ap, num);			//; ap ̾ΤʤꥹȤ
								//; ƬˤƤ

	void* obj;
	int j;
	for (j = 0; j < num; j++) {
		obj = va_arg(ap, void*);
		if (Register(obj) == NO) { //;  object_list ɲä
			Cprint();
			return NO;
		}
	}

	if (Make_object_array(iterator_array[i], number_of_iterators[i])
		!= YES) {
		Eprint(__FILE__, __LINE__);
			// Sub_system::Register(int, ...)
			// Cannot convert object_list to "iterator_array".
		fprintf(stderr, "\t\t iterator_array[%d]\n", i);
		return NO;
	}

	object_list->Clear();

	return YES;
}


// modified by Y.Ichikawa (Wed Dec 27 16:41:36 1995)
void* Sub_system::Get_component(char* c_name, char* o_name, int o_num)
{
	void* p;
	if ((p = Get_from_array(c_name, o_name, o_num,
		 component_array, number_of_components)) != NULL)
		return p;

	int i;
	for (i = 0; i < number_of_iterator_sets; i++) {
		if ((p = Get_from_array(c_name, o_name, o_num,
			iterator_array[i], number_of_iterators[i])) != NULL)
			return p;
	}

	//; Υ֥ȤϿƤʤä.
	Eprint(__FILE__, __LINE__);
		// Sub_system::Get_component(char*,char*,int)
		// Cannot get component from array.
	fprintf(stderr,
		"\tAsked > \'%s\' : \'%s\' : %d :\n", c_name, o_name, o_num);
	Oprint();
	return NULL;
}


// modified by Y.Ichikawa (Wed Dec 27 16:41:45 1995)
void* Sub_system::Get_component(char* o_name, int o_num)
{
	void* p;
	if ((p = Get_from_array(o_name, o_num,
		 component_array, number_of_components)) != NULL)
		return p;

	int i;
	for (i = 0; i < number_of_iterator_sets; i++) {
		if ((p = Get_from_array(o_name, o_num,
			iterator_array[i], number_of_iterators[i])) != NULL)
			return p;
	}

	//; Υ֥ȤϿƤʤä.
	Eprint(__FILE__, __LINE__);
		// Sub_system::Get_component(char*,int)
		// Cannot get component from array.
	fprintf(stderr,
		"\tAsked > \'%s\' : %d :\n", o_name, o_num);
	Oprint();
	return NULL;
}


// modified by Y.Ichikawa (Sat Nov 11 15:08:17 1995)
Boolean Sub_system::Construct(void)
{	//; 	Sub_system::Construct(void) (define)

/*
	if (object_list != NULL) {
		Eprint(__FILE__, __LINE__);
			// Sub_system::Construct(void)
			// "object_list" is in use.
			// Cannot make "receive_port_array" and "send_port_array".

TROUBLE:	//; 顼ν.
		Oprint(); return NO;
	}
*/

  if (object_list != NULL) { delete object_list; }

  if ((object_list = new List) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Sub_system::Construct(void)

  //; receive_port_array κ.
  Register_receive_ports();
  if (Make_object_array(receive_port_array, number_of_receive_ports)
		!= YES)
  { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Construct(void)
			// Cannot make "receive_port_array".

  object_list->Clear();

  //; send_port_array κ.
  Register_send_ports();
  if (Make_object_array(send_port_array, number_of_send_ports)
		!= YES) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Construct(void)
			// Cannot make "send_port_array".

  object_list->Clear();

  //; component_array κ.
  Register_components();
  if (Make_object_array(component_array, number_of_components) != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Construct(void)
			// Cannot make "component_array".

  object_list->Clear();

  //; iterator_array κ.
  //; Register_iterators  Register(int,...) ƤФ졢
  //; Register  Make_object_array 롣
  Initialize_iterator_array();
  Register_iterators();

  delete object_list; object_list = NULL;

  Boolean flag = YES;
  int i, k;
  for (k = 0; k < number_of_components; k++)
    if (((Element*) component_array[k])->Construct() != YES) flag = NO;
  for (i = 0; i < number_of_iterator_sets; i++) {
    for (k = 0; k < number_of_iterators[i]; k++) {
      if (((Element*) iterator_array[i][k])->Construct() != YES)
        flag = NO;
    }
  }
  if (flag != YES)
  { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Construct(void)
			// Cannot construct "components".

  Connect_ports();
  Connect_components();

  return YES;
}


// modified by Y.Ichikawa (Sat Nov 11 20:33:41 1995)
Element::OperationFlag Sub_system::Do_initial_work(void)
{
	Element::OperationFlag flag;
	Boolean calcany = NO, calcall = YES;

	if (initialworkdone_p == NO) {
		if (Initial_work() == YES) {
			initialworkdone_p = YES;
			calcany = YES;
		}
	}

	int i, k;
	for (k = 0; k < number_of_components; k++) {
		flag = ((Element*) component_array[k])->Do_initial_work();
		if (flag == Element::E_DONE) calcany = YES;
		if (flag == Element::E_UNDONE) calcall = NO;
	}
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			flag = ((Element*) iterator_array[i][k])->Do_initial_work();
			if (flag == Element::E_DONE) calcany = YES;
			if (flag == Element::E_UNDONE) calcall = NO;
		}
	}

//	if (calcall == YES) initialworkdone_p = YES;
	if (calcany == YES) return Element::E_DONE;
	if (calcall == YES) return Element::E_ALREADY;
	return Element::E_UNDONE;
}


// added by Yutaka ICHIKAWA (Sun Dec  1 17:40:27 1996)
Element::OperationFlag Sub_system::Do_share_info(void)
{
	Element::OperationFlag flag;
	Boolean calcany = NO, calcall = YES;

	if (shareinfodone_p == NO) {
		if (Share_info() == YES) {
			shareinfodone_p = YES;
			calcany = YES;
		}
	}

	int i, k;
	for (k = 0; k < number_of_components; k++) {
		flag = ((Element*) component_array[k])->Do_share_info();
		if (flag == Element::E_DONE) calcany = YES;
		if (flag == Element::E_UNDONE) calcall = NO;
	}
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			flag = ((Element*) iterator_array[i][k])->Do_share_info();
			if (flag == Element::E_DONE) calcany = YES;
			if (flag == Element::E_UNDONE) calcall = NO;
		}
	}

	if (calcany == YES) return Element::E_DONE;
	if (calcall == YES) return Element::E_ALREADY;
	return Element::E_UNDONE;
}


// modified by Y.Ichikawa (Sat Nov 11 20:37:38 1995)
Boolean Sub_system::Switch(void)
{	//;		Sub_system::Switch(void) (define)

	if (Element::Switch() != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Switch(void)

	Boolean	flag = YES;		//; Ƚѥե饰.
	int i, k;
	for (k = 0; k < number_of_components; k++)
		if (((Element*) component_array[k])->Switch() != YES) flag = NO;
			//; switch Ǥʤǥǥ뤬¸ߤ.
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			if (((Element*) iterator_array[i][k])->Switch() != YES) flag = NO;
				//; switch Ǥʤǥǥ뤬¸ߤ.
		}
	}

	if (flag != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); flag = NO; }
			// Sub_system::Switch(void)
			// Cannot switch those 'components'.

	return flag;
}


// modified by Y.Ichikawa (Sat Nov 11 20:39:08 1995)
Boolean Sub_system::Are_you_ready(void)
{	//;		Sub_system::Are_you_ready(void) (define)

	if (Element::Are_you_ready() != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Are_you_ready(void)

	Boolean	flag = YES;		//; Ƚѥե饰.
	int i, k;
	for (k = 0; k < number_of_components; k++)
		if (((Element*) component_array[k])->Are_you_ready() != YES)
			flag = NO;	//; ׻򳫻ϤǤʤ֥Ȥȯ.
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			if (((Element*) iterator_array[i][k])->Are_you_ready() != YES)
				flag = NO;	//; ׻򳫻ϤǤʤ֥Ȥȯ.
		}
	}

	if (flag != YES) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sub_system::Are_you_ready(void)
		// These 'components' are not ready.

	return flag;
}


// modified by Y.Ichikawa (Sat Nov 11 20:40:32 1995)
void Sub_system::Clear_data_string(void)
{	//;		Sub_system::Clear_data_string(void) (define)

	Element::Clear_data_string();

	int i, k;
	for (k = 0; k < number_of_components; k++)
		((Element*) component_array[k])->Clear_data_string();
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			((Element*) iterator_array[i][k])->Clear_data_string();
		}
	}
}


void Sub_system::Parameter(FILE* fp, char*& buffer, int buflen,
	Boolean& stock_p)
{
	Set_parameter(fp);			//; ʬȤΥѥ᥿ɤߤȤ

	int iflag;
	char* s = Get_line(fp, buffer, buflen, stock_p, iflag);
	if (s == NULL) return;

	if (iflag != '{') {
		stock_p = YES;			//; ɤԤɤޤʤäȤˤޤ
		return;
	}

	void* elm; char classname[81]; char objname[81];  int objnum;
	while ((s = Get_line(fp, buffer, buflen, stock_p, iflag))
		   != NULL) {

		if (iflag == '}') break;
		if (sscanf(s, "%s %s %d", classname, objname, &objnum) == 3) {
			elm = this->Get_component(classname, objname, objnum);
		}
		else if (sscanf(s, "%s %d", objname, &objnum) == 2) {
			elm = this->Get_component(objname, objnum);
		}
		else if (sscanf(s, "%s", objname) == 1) {
			elm = this->Get_component(objname, 0);
		}
		else {
			Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
			// illegal line
		}

		if (elm == NULL)
			{ Eprint(__FILE__, __LINE__, s); Oprint(); exit(1); }
			// non-member component

		((Element*)elm)->Parameter(fp, buffer, buflen, stock_p);
	}
}

void Sub_system::Set_initial_state(FILE* fp)
{
	int k;  time_t ct;
	if ( (k = fscanf(fp, "%ld", &ct)) != 1) {
		Eprint(__FILE__, __LINE__);
		// Sub_system::Set_initial_state(FILE* fp)
		// cannot read current_time.
		exit(1);
	}
	if (ct > 0) current_time = ct;
}

void Sub_system::Initial_state(FILE* fp, char*& buffer, int buflen,
	Boolean& stock_p)
{
	Set_initial_state(fp);			//; ʬȤν̤

	int iflag;
	char* s = Get_line(fp, buffer, buflen, stock_p, iflag);
	if (s == NULL) return;

	if (iflag != '{') {
		stock_p = YES;			//; ɤԤɤޤʤäȤˤޤ
		return;
	}

	void* elm; char classname[81]; char objname[81];  int objnum;
	while ((s = Get_line(fp, buffer, buflen, stock_p, iflag))
		   != NULL) {

		if (iflag == '}') break;
		if (sscanf(s, "%s %s %d", classname, objname, &objnum) == 3) {
			elm = this->Get_component(classname, objname, objnum);
		}
		else if (sscanf(s, "%s %d", objname, &objnum) == 2) {
			elm = this->Get_component(objname, objnum);
		}
		else if (sscanf(s, "%s", objname) == 1) {
			elm = this->Get_component(objname, 0);
		}
		else {
			Eprint(__FILE__, __LINE__, s); Oprint(); exit(1);
			// illegal line
		}

		((Element*)elm)->Initial_state(fp, buffer, buflen, stock_p);
	}
}


// modified by Y.Ichikawa (Sat Nov 11 20:43:10 1995)
void Sub_system::Save_send_port_stock(FILE* fp)
{   //    Sub_system::Save_send_port_stock(FILE* fp)

	int i, k;
	if (fp != NULL) {
		//; ǤˤĤ, send_port Υǡѥå¸롣
		if (number_of_components <= 0) return;
		if (number_of_components > 0) {
		  fprintf(fp, "%s %s %d\n", class_name, object_name, object_number);
		  fprintf(fp, "{\n");
			for (k = 0; k < number_of_components; k++) {
				((Element*) component_array[k])->Save_send_port_stock(fp);
			}
			for (i = 0; i < number_of_iterator_sets; i++) {
				for (k = 0; k < number_of_iterators[i]; k++) {
					((Element*) iterator_array[i][k])->
						Save_send_port_stock(fp);
				}
			}
			fprintf(fp, "}\n");
		}
	}
}


// modified by Y.Ichikawa (Sat Nov 11 17:32:21 1995)
void Sub_system::Print_components(FILE* fp, char* head)
{
	Print_objects(fp, head, "Components :",
		component_array, number_of_components);

	int i;
	for (i = 0; i < number_of_iterator_sets; i++)
		Print_objects(fp, head, "Components :",
			iterator_array[i], number_of_iterators[i]);
}


// modified by Y.Ichikawa (Sat Nov 11 20:45:02 1995)
Boolean Sub_system::Initial_time(time_t i_time)
{	//;		Sub_system::Initial_time(time_t) (define)

	if (Element::Initial_time(i_time) != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Initial_time(time_t)

	Boolean	flag = YES;		//; Ƚѥե饰.
	int i, k;
	for (k = 0; k < number_of_components; k++)
		if (((Element*) component_array[k])->Initial_time(i_time) != YES)
			flag = NO;
	for (i = 0; i < number_of_iterator_sets; i++) {
		for (k = 0; k < number_of_iterators[i]; k++) {
			if (((Element*) iterator_array[i][k])->
				Initial_time(i_time) != YES)
			flag = NO;
		}
	}

	if (flag != YES) { Eprint(__FILE__, __LINE__); Oprint(); }
		// Sub_system::Initial_time(time_t)
		// Cannot set initial time
		//     At those 'components' of this 'sub_system'

	return flag;
}


// modified by Y.Ichikawa (Sat Nov 11 20:50:28 1995)
void Sub_system::Terminal_state(FILE* fp)
{   //    Sub_system::Terminal_state(FILE* fp) (define)

	int i, k;
	if (fp != NULL) {
		//; ֥ƥͭξ¸
		fprintf(fp, "%s %s %d \n", class_name, object_name,
				object_number);
		Save_terminal_state(fp);
		fprintf(fp, "\n");

		//; Ǥξ¸
		fprintf(fp, "{\n");
		for (k = 0; k < number_of_components; k++) {
			if (k > 0) fprintf(fp, "\n");
			((Element*) component_array[k])->Terminal_state(fp);
		}
		for (i = 0; i < number_of_iterator_sets; i++) {
			for (k = 0; k < number_of_iterators[i]; k++) {
				fprintf(fp, "\n");
				((Element*) iterator_array[i][k])->Terminal_state(fp);
			}
		}
		fprintf(fp, "}\n");
	}
}


time_t Sub_system::Necessary_time_from(void* rp)
{
	int k, j = -1;
	for (k = 0; k < number_of_receive_ports; k++) {
		if (rp == receive_port_array[k]) j = k;
	}
	if (j == -1) return current_time;

	return ((Sender_port*)rp)->Necessary_time_from();
}


time_t Sub_system::Necessary_time_to(void* rp)
{
	int k, j = -1;
	for (k = 0; k < number_of_receive_ports; k++) {
		if (rp == receive_port_array[k]) j = k;
	}
	if (j == -1) return current_time;

	return ((Sender_port*)rp)->Necessary_time_to();
}


// added by Y.Ichikawa (Sat Nov 11 15:14:37 1995)
Boolean Sub_system::Do_you_reach_target_time(int num)
{
	int i; Boolean flag = YES;
	for (i = 0; i < number_of_iterators[num]; i++)
		if (((Element*) iterator_array[num][i])->
			Do_you_reach_target_time() == NO)
			flag = NO;

	return flag;
}


// added by Y.Ichikawa (Sat Nov 11 15:14:37 1995)
Boolean Sub_system::Do_you_converge(int num)
{
	int i; Boolean flag = YES;
	for (i = 0; i < number_of_iterators[num]; i++)
		if (((Element*) iterator_array[num][i])->Do_you_converge() == NO)
			flag = NO;

	return flag;
}


// modified by Y.Ichikawa (Sat Nov 11 15:07:56 1995)
Boolean Sub_system::Renew_current_time(void)
{	//		Sub_system::Renew_current_time(void) (define)

	int k; time_t buf[2]; buf[0] = LONG_MAX;

	// component_array
	for (k = 0; k < number_of_components; k++) {
		buf[1] = ((Element*) component_array[k])->Current_time();
		if (buf[1] < buf[0]) buf[0] = buf[1];
	}

	//; iterator_array
	//; k Ǥ fixed_time ϤɤǤƱʤΤǡ
	//; iterator_array[k][0] ˤʹʤ
	for (k = 0; k < number_of_iterator_sets; k++) {
		buf[1] = ((Element*) iterator_array[k][0])->Fixed_time();
		if (buf[1] < buf[0]) buf[0] = buf[1];
	}

	if (buf[0] < current_time) {
		Wprint(__FILE__, __LINE__);
			// Sub_system::Renew_current_time(void)
		fprintf(stderr,
			"\tPut back current_time from %ld to %ld.\n",
			current_time, buf[0]);
		Oprint(); return NO;
	}

	current_time = buf[0]; return YES;
}


// added by Y.Ichikawa (Sat Nov 11 15:15:25 1995)
void Sub_system::Rewind_current_time(int num)
{
	int i;
	for (i = 0; i < number_of_iterators[num]; i++)
		((Element*) iterator_array[num][i])->
			Rewind_current_time();
}


// added by Y.Ichikawa (Thu Nov 16 14:42:03 1995)
void Sub_system::Flush_data(int num)
{
	int i;
	for (i = 0; i < number_of_iterators[num]; i++)
		((Element*) iterator_array[num][i])->Flush_data();
}


// added by Y.Ichikawa (Thu Nov 16 14:42:03 1995)
void Sub_system::Renew_fixed_time(int num)
{
	int i;
	for (i = 0; i < number_of_iterators[num]; i++)
		((Element*) iterator_array[num][i])->Renew_fixed_time();
}


// added by Y.Ichikawa (Thu Nov 16 14:42:03 1995)
void Sub_system::Renew_target_time(int num, time_t itrs)
{
	int i;
	for (i = 0; i < number_of_iterators[num]; i++)
		((Element*) iterator_array[num][i])->Renew_target_time(itrs);
}


// added by Y.Ichikawa (Thu Nov 16 14:42:03 1995)
void Sub_system::Initialize_target_time(void)
{
	int i;

	// iterator_array
	for (i = 0; i < number_of_iterator_sets; i++)
		Renew_target_time(i, Calculate_iteration_step(i));

	// component_array
	for (i = 0; i < number_of_components; i++)
		((Element*) component_array[i])->Initialize_target_time();
}


// added by Y.Ichikawa (Thu Nov 16 14:42:03 1995)
time_t Sub_system::Calculate_iteration_step(int num)
{
	int i;
	time_t buf[2]; buf[0] = LONG_MAX;

	for (i = 0; i < number_of_iterators[num]; i++) {
		buf[1] = ((Element*) iterator_array[num][i])->
			Calculate_iteration_step();
		if (buf[1] < buf[0]) buf[0] = buf[1];
	}

	return buf[0];
}


Boolean Sub_system::Work(void)
{	//;		Sub_system::Work(void) (define)

  int i, j, k;
  Boolean calc = NO, flag_all, flag_itr;
  //; calc		: ؿƤФư٤Ǥ׻ɤ
  //; flag_all : (ȿ׻Ǥޤ)ĤǤ׻ YES
  //; flag_itr : ȿ׻ǤĤǤ׻ YES

	int* itrcounter = new int[number_of_iterator_sets];
	for (i = 0; i < number_of_iterator_sets; i++) itrcounter[i]	= 0;

	//; Ǥη׻.
	do {
      flag_all = NO;

      // component_array
      for (k = 0; k < number_of_components; k++) {
        if (((Element*) component_array[k])->Work() == YES)
        { calc = flag_all = YES; break; }
      }
      while (++k < number_of_components)
        ((Element*) component_array[k])->Work();

      // iterator_array
      for (i = 0; i < number_of_iterator_sets; i++) {
        do {
          flag_itr = NO;
          for (j = 0; j < number_of_iterators[i]; j++) {
            if (((Element*) iterator_array[i][j])->
              Work() == YES) {
              calc = flag_all = flag_itr = YES;
              break;
            }
          }
          while (++j < number_of_iterators[i])
            ((Element*) iterator_array[i][j])->Work();

        } while (flag_itr == YES);

        //; i Ǥȿ׻ɸãƤ뤫
        if (Do_you_reach_target_time(i) == YES) {
          //; «Ƥ뤫
          if (Do_you_converge(i) == YES) {
            //; ޤäǡϤ
            Flush_data(i);
            //; fixed_time 򹹿
            Renew_fixed_time(i);
            //; ȿ׻ɸꤵ
            Renew_target_time(i, Calculate_iteration_step(i));
            //; itrcounter  0 ᤹
            itrcounter[i] = 0;
          }
          else {
            //; current_time 򴬤᤹
            Rewind_current_time(i);
            //; itrcounter  1 䤹
            if (++itrcounter[i] >= 1000) {
              Eprint(__FILE__, __LINE__);
              // Sub_system::Work(void)
              // Iterative calculation cannot converge
              fprintf(stderr, "tin group [%d].\n", i);
              Oprint(); exit(1);
            }
          }
        }
      }
	} while (flag_all == YES);

	//; ׻Ǥʤä.
	if (calc == NO) {
      delete [] itrcounter;
      return NO;
	}

	//; current_time ι.
	if (Renew_current_time() != YES)
    { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
    // Sub_system::Work(void)

	//; ׻.
	delete [] itrcounter;
	return YES;
}


// added by Y.Ichikawa
Boolean Sub_system::Init(char* o_name, int o_num,
						 int num_of_objs, int num_of_itr, char* p_line)
{
	if (num_of_itr < 0) {
		Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Sub_system::Init(void)
			// Invalid argument for "number_of_iterator_sets".

	number_of_iterator_sets = num_of_itr;
	return Element::Init(o_name, o_num, num_of_objs, p_line);
}


// modified by Y.Ichikawa (Fri Jan 12 12:26:46 1996)
Boolean Sub_system::Init(char* o_name, int o_num,
						 int num_of_objs, char* p_line)
{
	return Init(o_name, o_num, num_of_objs, 0, p_line);
}


// added by Y.Ichikawa
Sub_system::Sub_system(char* o_name, int o_number,
					   int num_of_objs, int num_of_itr, char* p_line)
	:	Element(),
		component_array(NULL), number_of_components(-1)
{	//;		Sub_system::Sub_system(char*,int,int,char*) (define)

	class_name = "Sub_system";
	Init(o_name, o_number, num_of_objs, num_of_itr, p_line);
}


// modified by Y.Ichikawa (Fri Jan 12 12:26:46 1996)
Sub_system::Sub_system(char* o_name, int o_number,
					   int num_of_objs, char* p_line)
	:	Element(),
		component_array(NULL), number_of_components(-1)
{	//;		Sub_system::Sub_system(char*,int,int,char*) (define)

	class_name = "Sub_system";
	Init(o_name, o_number, num_of_objs, 0, p_line);
}


// modified by Y.Ichikawa
Sub_system::Sub_system(char* o_name, int o_number, char* p_line)
	:	Element(),
		component_array(NULL), number_of_components(-1)
{	//;		Sub_system::Sub_system(char*,int,char*) (define)

	class_name = "Sub_system";
	Init(o_name, o_number, 0, 0, p_line);
}


Sub_system::Sub_system(void)
	:	Element(),
		component_array(NULL), number_of_components(-1)
{	//;		Sub_system::Sub_system(void) (define)

	class_name = "Sub_system";
}


// modified by Y.Ichikawa
Sub_system::~Sub_system(void)
{	//;		Sub_system::~Sub_system(void) (define)

	delete [] component_array;

	int i;
	for (i = 0; i < number_of_iterator_sets; i++)
		delete [] iterator_array[i];
	delete [] iterator_array;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
