/*;  sub.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl sub.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:59:47 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/sub.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) sub.h -- base class for creating subsystems

#if !defined(sub_h)
#define sub_h

#include <stdio.h>
#include <stdlib.h>
#include <time.h>       //; time_t , tm 
#include <stdarg.h>     //; ѰŸޥ
                        //; Register(int,...) Ѥ.
#include "common.h"     //; ̴Ķʤ
#include "element.h"    //; 饹 Element 


//; 饹 Sub_system 

/*----------------------------------------------------------------------
CLASS
    Sub_system

DESCRIPTION
    subsystem class.

    <japanese>
    ʬϥǥ, ǡʬϤʤʣΥ󥹥 (ʲ, )
    ˤ깽ǥǤ ܥƥǤ, ʬϥǥϸ§Ȥ
    ƿ׻Ԥ鷺, ǡľܽȤ, Ǥ
    ԤΤȤޤ ä, ʬϥǥη׻Ȥ, 
    ˽缡׻̿뤳Ȥˤʤޤ Ȥ, ʬϥǥ, 
    üҡüҤͭޤ, üҤϿ
    ³³, ǥǥμüҡüҤξƱμ³
    Ǥޤ

    ܥƥǤʬϥǥ򿷤˺ΤǤϤʤ, ǥ
    Ѿƺ뤳ȤȤޤ ʬϥǥǤ, ü
    ҡüҤ Element::receive\_port\_array,
    Element::send_port_array ˵Ƥޤ ޤ, üҤϿ˴
    {\tt Element} Υдؿ, ǤϿȤˤѤ, üҤ
    ϿƱμ³ǹǤϿԤ, ʬϥǥԤ
    Ƥޤ

    ʬϥǥǤ, 嵭Τ褦ϿƹǡüҴ֤³
    ʤФʤޤ󡣤, ܷʬϥǥ³ΤΥ
    дؿƤΤ, ܷʬϥǥѾƺ
    ʬϥǥǤ, ³ȤϴܷʬϥǥΥдؿ˰
    ͿΤߤκȤñ㲽Ƥޤ

    ܷʬϥǥɽ饹 Sub_system ǿɲä줿ǡ
    , дؿ, ޤ Element ȰۤʤƤ˺줿
    дؿϰʲ̤Ǥ

    <ul>
    <li> ǡݥ
      <dl>
        <dt>component_array       <dd> ǤΥɥ쥹
        <dt>number_of_components  <dd> component_array ǿ
      </dl>
    <li> дؿ
       <dl>
        <dt>Connect               <dd> ƹǡüҴ֤³
       </dl>
    <li> дؿκ
       <dl>
        <dt>Construct             <dd> receive_port_array, send_port_array,
                                  object_array , ³ط
                                  äʬ³Ԥ.
        <dt>Work                  <dd> ƹǤ˽缡׻¹̿.
       </dl>
    </ul>

    ǡʬϤɤľ̿Ѥȿ׻Ԥʤˤϡ
    ͭʬϤɬפޤ

    ȿ׻ΤΥǡФϤĤΤ褦Ǥ

    <dl>
        <dt>void*** iterator_array
              <dd>ȿ׻ǷΥɥ쥹
        <dt>number_of_iterator_sets
              <dd>ȿ׻Ƿο(󥹥ȥ饯ǽ)
        <dt>int* number_of_iterators
              <dd>ȿ׻Ƿ˴ޤޤǤοǼ
     </dl>

    ȿ׻ΤΥдؿϤĤΤ褦Ǥ

    <dl>
        <dt>Initialize_iterator_array
              <dd>iterator_array Ǥ number_of_iterator_sets
                Ĥˤ.
        <dt>Register_iterators (pure virtual)
              <dd>ȿ׻Ǥ iterator_array Ͽ.
    </dl>

    </japanese>

----------------------------------------------------------------------*/

class Sub_system : public Element {
//  0.  ǡ.

protected:
  //////////////////////////////////////////////////////////////////////
  // Pointer to the area where the pointers to the constituent elements
  // are stored.
  //
  // <japanese>
  // ֥ȵ
  // </japanese>
  void**    component_array;

  //////////////////////////////////////////////////////////////////////
  // Number of constituent elements
  int       number_of_components;

// added by Y.Ichikawa (Sat Nov 11 14:58:16 1995)
  //////////////////////////////////////////////////////////////////////
  void*** iterator_array;        //; ȿ׻빽ǵ
  //////////////////////////////////////////////////////////////////////
  int number_of_iterator_sets; //; ȿ׻Ƿο
  //////////////////////////////////////////////////////////////////////
  int* number_of_iterators;  //; ǷǤο

//; 1.  receive_port_array, send_port_array, component_array κ, .
protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ¦üҤϿޤ饹ޤConstruct 
  // ƤФޤϿƤʤ¦üҤ³Ǥޤ.
  // </japanese>
  void Register_receive_ports(void) = 0;

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ¦üҤϿޤ饹ޤConstruct 
  // ƤФޤϿƤʤ¦üҤ³Ǥޤ.
  // </japanese>
  void Register_send_ports(void) = 0;

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǤΤ, ȿ׻Ԥʤʤ֥ȤΥɥ쥹
  // component_array Ͽޤ.
  //
  // ϿƤʤ֥Ȥˤ, ׻¹̿᤬ޤ.
  //
  // 㤨, 饹ǹ֥ abc ǡФȤ
  // , Τ褦 abc Ͽޤ.
  // <pre>
  //   void Register_components(void) { Register((void*) &abc); }
  // </pre>
  // λ, ɬ &abc  void* ˥㥹ȤƲ.
  //
  // ˤ &abc , Ū object_list ˼Ͽ줿, ǽŪ
  // void*  component_array ˵ޤ.
  // (Sub_system::Construct )
  //
  // </japanese>
  virtual void Register_components(void) = 0;

//; added by Y.Ichikawa (Sat Nov 11 15:00:10 1995)
  //////////////////////////////////////////////////////////////////////
  void Initialize_iterator_array(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Register_iterators , ǤΤ, ȿ׻ԤʤǤΥ
  // 쥹 iterator_array Ͽޤ. ȿ׻Ԥʤʬϥǥ
  // ˺ץޤδؿʤФʤޤ
  //
  // Ʊͤˡ饹ȿ׻빽֥ def, gih
  // ǡФȤ, Τ褦 def, gih Ͽޤ.
  // <pre>
  //   void Register_iterators(void)
  //     { Register(2, (void*) &def, (void*) &gih); }
  // </pre>
  // ǽΰȿ׻륪֥ȤοǤ.
  // ˤ &def, &gih , Ū object_list ˼Ͽ
  // 줿, ǽŪ void*  iterator_array ˵ޤ.
  //
  // </japanese>
  virtual void Register_iterators(void) = 0;

  //////////////////////////////////////////////////////////////////////
  Boolean Register(int num, ...);

  //////////////////////////////////////////////////////////////////////
  Boolean Register(void* p) { return Element::Register(p); }

public:
  //////////////////////////////////////////////////////////////////////
  Boolean Register(void* p, int obj)
        { return Element::Register(p, obj); }
    //; Register(void*), Register(void*, int) ϡRegister(int,...) 
    //; Element::Register(void*)  override Τɤˤ
    //; (See A.R.M. pp. 389 -- 391)

public:
//; modified by Y.Ichikawa (Sat Nov 11 16:25:08 1995)
//; iterator_array ɲäбƽľ

//;     void* Get_component(char* c_name, char* o_name, int o_num)
//;         { return Get_from_array(c_name, o_name, o_num,
//;                                 component_array, number_of_components); }
//;     void* Get_component(char* o_name, int o_num)
//;         { return Get_from_array(o_name, o_num,
//;                                 component_array, number_of_components); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Get_component , 饹̾, ֥̾, ֹ֥
  // ꤷ, component_array , ֥ȤΥɥ쥹 (void*
  // ) ޤ.
  //
  // ꤵ줿֥ȤΥɥ쥹ϿƤʤ, NULL 
  // ֤ޤ.
  //
  // number_of_components ξ, component_array Ƥ
  // ȽǤ, 顼åɽ NULL ֤ޤ.
  //
  // <pre>
  //
  //    ARGUMENT:
  //        c_name    빽֥ȤΥ饹̾.
  //        o_name    빽֥ȤΥ֥̾.
  //        o_num     빽֥ȤΥֹ֥.
  //    RETURN:
  //        void*     ꤵ줿֥ȤΥɥ쥹.
  //                    Υ֥ȤǤʤ NULL.
  //    ACCIDENT:
  //        component_array  Object* ʳѿ void* ˥㥹
  //         ƼϿƤ.
  // </pre>
  // </japanese>
  void* Get_component(char* c_name, char* o_name, int o_num);
  //////////////////////////////////////////////////////////////////////
  void* Get_component(char* o_name, int o_num);

//; 2.  ֥Ȥ³.
protected:
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* my_p,
                    void* r, char* rp_c_name, char* rp_name, int rp_num);
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* s, char* sp_c_name, char* sp_name, int sp_num,
                    void* r, char* rp_c_name, char* rp_name, int rp_num);
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* s, char* sp_c_name, char* sp_name, int sp_num,
                    void* my_p);

  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* my_p,
                    void* r, char* rp_name, int rp_num);
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* s, char* sp_name, int sp_num,
                    void* r, char* rp_name, int rp_num);
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* s, char* sp_name, int sp_num,
                    void* my_p);
  //////////////////////////////////////////////////////////////////////
  Boolean Connect(void* my_sp, void* my_rp);
        /* <japanese>
          Sub_system::Connect(void*,void*,char*,char*,int) (protected)
          Sub_system::Connect(void*,char*,char*,int,
                                void*,char*,char*,int) (protected)
          Sub_system::Connect(void*,char*,char*,int,void*) (protected)
                ֥ȤüҤ³

        ʬϥǥüҴ֤³Ԥޤ. 夫,
            ¦ü, ֥ȤμüҤ³
            ֥Ȥμü, üҤ³
            ֥Ȥü, ¦üҤ³
        Ԥʤޤ.

        ͭüҤʬϥǥ볰ü, ü, üҤȤ
        ֤³, owner Ԥޤ.

        饹̾ΥåάǤɲäޤ(Shiiba)

        ARGUMENT:
            s             üҤͭ빽֥ȤΥɥ쥹
                             void* ˥㥹Ȥ.
            sp_c_name     s üҤΥ饹̾.
            sp_name                     ü̾.
            sp_num                      üֹ.
            r             üҤͭ빽֥ȤΥɥ쥹
                             void* ˥㥹Ȥ.
            rp_c_name     r μüҤΥ饹̾.
            rp_name                     ü̾.
            rp_num                      üֹ.
            my_p          ³ͭüҤΥɥ쥹 void* ˥
                            㥹Ȥ.
            my_sp         üҤΥɥ쥹 void* ˥㥹Ȥ.
            my_rp         üҤΥɥ쥹 void* ˥㥹Ȥ.
        RETURN:
            YES           ³Ǥ.
            NO            ꤷ֥ȤޤüҤǤ
                            ʤ.
                            Port::Set_sender ͤ NO ξ.
                            Port::Register_receiver ͤ NO ξ.
        EXIT:
            Level 5       Port::Register_receiver Ƕλ.
        </japanese> */
protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϥǥüҤ³ Sub_system::Connect Ѥ
  // ޤ.
  // </japanese>
  virtual void Connect_ports(void) = 0;

protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϥǥľ̿³ Element::Register(void*,int) 
  // Ѥޤ.  㤨СΤ褦ޤ
  //
  // EXAMPLE
  // void Connect_components(void) {
  //   a.Register(&b, 0);
  //   b.Register(&a, 0);
  //   a.Register(&c, 1);
  //   c.Register(&a, 0);
  // }
  // END
  //
  // , a, b, c , ʬϤΥǡФǤˤ, 
  // a  object_array[0]  b Υɥ쥹Ǽ,  a 
  // object_array[1]  c Υɥ쥹Ǽ뤳Ȥˤʤޤ
  // b  object_array[0]  a Υɥ쥹Ǽޤ c 
  // object_array[0]  a Υɥ쥹Ǽޤ
  //
  // 貾۴ؿʤΤ, 饹ɬƲ.
  //
  // </japanese>
  virtual void Connect_components(void) = 0;
        /* <japanese>
          Sub_system::Connect_components(void) (pure virtual)
                ʬϥǥι֥Ȥ³

        ʬϥǥľ̿³ Element::Register(void*,int) 
        Ѥޤ.  㤨СΤ褦ޤ

        void Connect_components(void) {
            a.Register(&b, 0);
            b.Register(&a, 0);
            a.Register(&c, 1);
            c.Register(&a, 0);
        }

        , a, b, c , ʬϤΥǡФǤˤ, 
         a  object_array[0]  b Υɥ쥹Ǽ,  a 
        object_array[1]  c Υɥ쥹Ǽ뤳Ȥˤʤޤ
         b  object_array[0]  a Υɥ쥹Ǽޤ
         c  object_array[0]  a Υɥ쥹Ǽޤ

        貾۴ؿʤΤ, 饹ɬƲ.
        </japanese> */
public:
//; modified by Y.Ichikawa (Sat Nov 11 15:04:17 1995)
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϥǥ, ֥Ȥι¤ꤷޤ.
  //
  // Construct Ǥ, ޤ object_list  NULL Ǥ뤳Ȥǧޤ.
  // NULL Ǥʤ object_list ȽǤ, 顼å
  // ɽ return ޤ.
  //
  // , ʲμ³˽ޤ.
  //
  // <ol>
  // <li> List ֥Ȥҡפ˺ object_list ꤹ.
  // <li> Element::Register_receive_ports, Element::Make_object_array
  //      ˤ receive_port_array .
  // <li> List::Clear ˤ object_list ˤ.
  // <li> Element::Register_send_ports, Element::Make_object_array ˤ
  //             send_port_array .
  // <li> List::Clear ˤ object_list ˤ.
  // <li> Sub_system::Register_components, Element::Make_object_array
  //            ˤ component_array .
  // <li> List::Clear ˤ object_list ˤ.
  // <li> Sub_system::Initialize_iterator_array ˤ
  //      iterator_array 켡ݤ.
  // <li> Sub_system::Register_iterators ˤ iterator_array
  //      .
  // <li> object_list  delete , NULL ꤹ.
  // <li> Element::Construct ˤ, ֥Ȥι¤ꤹ.
  // <li> Sub_system::Connect_components ˤ, ʬϥǥ
  //      ³Ԥ.
  // </ol>
  //
  //  RETURN:
  // <dl>
  // <dt>YES  <dd> ʬϥǥι¤ꤵ줿.
  // <dt>NO   <dd> Υ֥Ȥι¤˰۾郎.
  //                    ֥Ȥι¤˰۾郎.
  //                    ʬϥǥ³˰۾郎.
  // </dl>
  // </japanese>
  Boolean Construct(void);
        /* <japanese>
          Sub_system::Construct(void) (virtual)
                ʬϥǥι¤

        ʬϥǥ, ֥Ȥι¤ꤷޤ.

        Construct Ǥ, ޤ object_list  NULL Ǥ뤳Ȥǧޤ.
        NULL Ǥʤ object_list ȽǤ, 顼å
        ɽ return ޤ.

        , ʲμ³˽ޤ.

        1.  List ֥Ȥҡפ˺ object_list ꤹ.
        2.  Element::Register_receive_ports, Elenment::Make_object_array
            ˤ receive_port_array .
        3.  List::Clear ˤ object_list ˤ.
        4.  Element::Register_send_ports, Element::Make_object_array ˤ
             send_port_array .
        5.  List::Clear ˤ object_list ˤ.
        6.  Sub_system::Register_components, Element::Make_object_array
            ˤ component_array .
        7.  List::Clear ˤ object_list ˤ.
        8.  Sub_system::Initialize_iterator_array ˤ
            iterator_array 켡ݤ.
        9.  Sub_system::Register_iterators ˤ iterator_array
            .
        10. object_list  delete , NULL ꤹ.
        11. Element::Construct ˤ, ֥Ȥι¤ꤹ.
        12. Sub_system::Connect_components ˤ, ʬϥǥ
            ³Ԥ.

        RETURN:
            YES   ʬϥǥι¤ꤵ줿.
            NO    Υ֥Ȥι¤˰۾郎.
                    ֥Ȥι¤˰۾郎.
                    ʬϥǥ³˰۾郎.
        </japanese> */
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҤ³˻ѤƤüҤΥǡΤ˻
  // Ѥ褦ˤޤˤꡢ³Ȥλơ
  // ϤΤνȤ򤷤ޤ
  //
  // ʬϥǥ¸ߤüҤ Switch (virtual) ¹Ԥ
  // .
  //
  // Relay_port Ǥ receiver_array ޤ.
  // Send_port Ǥ, receiver_array , buffer_list ǡ
  // åϿѤ˺ޤ.
  //
  // ޤ Element::Switch ¹Ԥ, ͤ NO ξ, 顼
  // ɽ NO ֤ޤ.
  //
  // , ֥Ȥ Switch (virtual) ¹Ԥޤ.
  // ͤ NO ι֥Ȥ¸ߤ, 
  // Ȥ Switch ¹Ԥ, 顼åɽ NO
  // ֤ޤ.
  //
  // <pre>
  //   RETURN:
  //     YES   ʬϥǥüҤžǤ.
  //     NO    ʬϥǥüҤ, žǤʤΤ
  //             ¸ߤ.
  // </pre>
  //
  // </japanese>
  Boolean Switch(void);

public:
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ׻γǧ
  //
  // δؿͤ YES ʤ, Sub_system Ϸ׻򳫻ϤǤޤ.
  //
  // ޤ Element::Are_you_ready Ѥ, ͭ¦ü, ͭ
  // ¦üҤФƷ׻γǧȤԤޤ.
  // ͤ NO ξ, 顼åɽ NO ֤ޤ.
  //
  // , ֥Ȥ Are_you_ready (virtual) ѤƷ׻
  // γǧȤԤޤ.
  // ͤ NO Υ֥Ȥ¸ߤ, ֥
  // Ȥ Are_you_redy ǳǧ, 顼åɽ NO ֤
  // ޤ.
  //
  // <pre>
  //     RETURN:
  //        YES   ׻ϲ.
  //        NO    ׻Բ.
  // </pre>
  // </japanese>
  Boolean Are_you_ready(void);

//; 4.  ǽ
public:
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ֥ȤΥǡʸξõ
  // </japanese>
  void Clear_data_string(void);

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Set_parameter ϡElement ν貾۴ؿǤɸŪʬϥǥ
  // , Ū֥ȤˤԤΤ, ѥ᡼, 
  // ʤΤȹͤޤ.  , Sub_system ǡ⤷ʤ
  // ޤ
  // ۴ؿʤΤ, ɬפʤ饹ѹƲ.
  // </japanese>
  void Set_parameter(FILE*) {}

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Paramter ϡʬϼȤΥѥ᥿ȡʬϤιǤΥѥ᥿
  // ߼ޤ
  // </japanese>
  void Parameter(FILE* fp, char*& buffer, int buflen,
                Boolean& stock_p);

public:
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ֥Ȥλν
  //
  // current_time ɤ߹ߤޤɤ߹ͤ 0 ʤ顤current_time
  // ѹޤ
  // </japanese>
  Boolean Initial_time(time_t i_time);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϼȤν̤
  // </japanese>
  void Set_initial_state(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϼȤȽ̤ȹ֥Ȥν̤
  // </japanese>
  void Initial_state(FILE* fp, char*& buffer, int buflen,
        Boolean& stock_p);

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϼȤκǽ֤Υեؤ¸
  // </japanese>
  virtual void Save_terminal_state(FILE* fp) {
        if (fp != NULL) {
            fprintf(fp, "%ld", current_time);
        }
    }

//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϼȤκǽ֤ȹǤκǽ֤¸
  //
  // Sub_system::Terminal_state(FILE* fp) ϡǤ˺ǽ֤
  // Ф褦˻ޤ
  // </japanese>
  virtual void Terminal_state(FILE* fp);

//; added by Yutaka ICHIKAWA (Sun Dec  1 17:20:52 1996)
public:
  //////////////////////////////////////////////////////////////////////
  virtual Element::OperationFlag Do_share_info(void);
    //; Sub_system::Do_share_info  Element Ƥ
    //; ۴ؿǤSub_system::Do_share_info ϡޤʬ
    //; Ф Share_info ¹Ԥ˼ʬιǤФ
    //;  Do_share_info ¹ԤޤʬޤưĤǤ
    //; Share_info ¹ԤǤ E_DONE ֤ޤ
    //; ƤǤǤ Share_info ¹ԤƤ E_ALREADY
    //; ֤ޤɤξǤʤȤ E_UNDONE ֤
    //; 

public:
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ʬϤιǤΤ줾˻ꡢեݥ fp ǻ
  // Ƥե˽񤭽Фޤ
  // </japanese>
  virtual void Save_send_port_stock(FILE* fp);

//; 5.  ϵǽ.
public:
//; modified by Y.Ichikawa (Sat Nov 11 16:32:40 1995)
//; iterator_array ɲäбƽľ

//;     void Print_components(FILE* fp = stderr, char* head = "    ")
//;         { Print_objects(fp, head, "Components :",
//;                         component_array, number_of_components); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ֥Ȥξޤ
  // </japanese>
  void Print_components(FILE* fp = stderr, char* head = "    ");

//; 6.  ׻μ¹Եǽ
protected:
  //////////////////////////////////////////////////////////////////////
  Boolean Initial_output(void) { return YES; }
public:
  //////////////////////////////////////////////////////////////////////
  Boolean Initial_work(void) { return YES; }

//; modified by Y.Ichikawa (Sat Nov 11 17:33:54 1995)
//; iterator_array ɲäбƽľ
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ν
  // </japanese>
  virtual Element::OperationFlag Do_initial_work(void);

public:
  //////////////////////////////////////////////////////////////////////
  virtual time_t Necessary_time_from(void* rp);
  //////////////////////////////////////////////////////////////////////
  virtual time_t Necessary_time_to(void* rp);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ׻γǧ
  // </japanese>
  Boolean Can_you_calculate(void) { return YES; }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ॹƥåפη׻
  // </japanese>
  time_t Calculate_time_step(void) { return 0; }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ƥåʬη׻
  // </japanese>
  Boolean Calculate(void) { return YES; }

public:
//; added by Y.Ichikawa (Sat Nov 11 15:05:23 1995)
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ȿ׻Ƿȿ׻ɸãɤå
  // . sub.cc Ǥϡشԡ٤ȤƤ Sub_system Ω줫
  // ޤʤʬȿ׻ԤʤǷȤ
  // ȤȤƤꡢʬȤȿ׻Ԥʤб
  // Ƥ櫓ǤϤޤ󡣤äơʬȤȿ׻Ԥʤ
  // ϡ줬ǽǤ褦˺Ʋ
  //
  // </japanese>
  Boolean Do_you_reach_target_time(int num);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ȿ׻Ƿ«å. sub.cc Ǥϡشԡ
  // ȤƤ Sub_system Ω줫Ƥޤʤʬ
  // ȿ׻ԤʤǷȤȤȤƤꡢʬ
  // Ȥȿ׻ԤʤбƤ櫓ǤϤޤ
  // äơʬȤȿ׻Ԥʤϡ줬ǽǤ褦
  // ˺Ʋ
  // </japanese>
  Boolean Do_you_converge(int num);

protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ߻ι
  //
  // component_array ϿƤǤcurrent_time 
  // iterator_array ϿƤǤ fixed_time ΤǤ٤
  // Τʬ current_time Ȥ롣
  // </japanese>
  Boolean Renew_current_time(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ȿ׻«ʤäǷ(iterator_array[num])Ф
  // Rewind_current_time ¹Ԥ褦᤹̿.
  // </japanese>
  void Rewind_current_time(int num);

  //////////////////////////////////////////////////////////////////////
  void Flush_data(int num);
  //////////////////////////////////////////////////////////////////////
  void Renew_fixed_time(int num);
  //////////////////////////////////////////////////////////////////////
  void Renew_target_time(int num, time_t itrs);
  //////////////////////////////////////////////////////////////////////
  void Initialize_target_time(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Calculate_iteration_step  iterator_array[num] 
  // Calculate_iteration_step ͤΤǾ֤ͤ
  // </japanese>
  time_t Calculate_iteration_step(int num);

public:
//; modified by Y.Ichikawa (Sat Nov 11 15:16:10 1995)
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // 黻ǽ
  // </japanese>
  Boolean Work(void);

//; 6.  ǽ, 󥹥ȥ饯, ǥȥ饯.
public:
//; added by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ؿ
  // </japanese>
  Boolean Init(char* o_name, int o_num,
        int num_of_objs = 0, int num_of_itr = 0, char* p_line = NULL);
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ؿ
  // </japanese>
  Boolean Init(char* o_name, int o_num,
                 int num_of_objs = 0, char* p_line = NULL);

//; added by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  Sub_system(char* o_name, int o_num,
        int num_of_objs = 0, int num_of_itr = 0, char* p_line = NULL);
//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Sub_system(char*,int,int,char*) , 쥯饹 Element Υǥե
  // ȥ󥹥ȥ饯Ѥ, Sub_system::Init ¹Ԥ, Фʲ
  // ̤ޤ.
  //
  // <pre>
  //        class_name                : "Sub_system"
  //        object_name               : o_name
  //        object_number             : o_num
  //        owner                     : NULL
  //        object_list               : NULL
  //        receive_port_array        : NULL
  //        number_of_receive_ports   : -1
  //        send_port_array           : NULL
  //        number_of_send_ports      : -1
  //        element_array             : NULL
  //        number_of_elements        : -1
  //        data_string               : NULL
  //        current_time              : 0
  //        time_step                 : -1
  //        componemt_array           : NULL
  //        number_of_components      : -1
  // </pre>
  // </japanese>
  Sub_system(char* o_name, int o_num,
        int num_of_objs = 0, char* p_line = NULL);

//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  //
  // </japanese>
  Sub_system(char* o_name, int o_num, char* p_line);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǥեȥ󥹥ȥ饯 Sub_system::Init ¹Ԥޤ.
  // η̰ʲȤʤޤ.
  //
  // <pre>
  //        object_name               : NULL
  //        object_number             : -1
  // </pre>
  //
  // ¾ΥФФ, Ĥ󥹥ȥ饯ƱǤ.
  // ξ, Sub_system::Init ѤƥФƲ.
  //
  // </japanese>
  Sub_system(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǥȥ饯 component_array  delete ޤ. ǥȥ饯, 
  // ܴ쥯饹 Object  virtual Ƥޤ.
  // </japanese>
  ~Sub_system(void);

};

#endif  // ! sub_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
