#!/usr/local/bin/perl
#
# @(#) drawfigure.pl
#
# $RCSfile$  $Revision$
# $Date$  by KyotoHydro
# $RCShost$

#  $ARGV[0], $ARGV[1], ... $ARGV[$#ARGV]

# sub usage {
#   print "usage: $0 fileName\n";
#   exit 1;
# }

sub usage {
   print "usage: $0 fileName\n";
   exit 1;
}

if ($#ARGV < 0) { &usage; }

$file = $ARGV[0];

open(OUT,">foo.gp");
print OUT <<"END";
#! /usr/local/bin/gnuplot
# \@(#) generated by drawfigure.pl

## tgif
#set term tgif "Helvetica" 18
#set output "foo.obj"
#set size 0.6, 0.5

# xmin = -pi
# xmax = pi
# ymin = -1.1
# ymax = 1.1
# set xrange [xmin:xmax]
# set yrange [ymin:ymax]

# no explanation of line
set nokey

# x-axis and y-axis
set xdata time
set xlabel "time"
set ylabel "discharge (m\$^3\$/sec)"
tbase = 946652400
time(t) = t - tbase

# plot
# plot "foo.dat" u 1:2 t 'sample line' with lines
plot "$file" u (time(\$1)):2 w l
pause -1 "Hit return key"
END

close(OUT);
exec 'gnuplot', 'foo.gp';

## Local Variables: ***
## mode: Perl ***
## fill-column: 62 ***
## End: ***
