/* vary.cc {\documentstyle{jsrc2latex}\rhead{\sl vary.cc\quad\thepage}
   \font\tenrm=cmtt10}Vary Υǡϼ
{\ \begin{verbatim}
$RCSfile: vary.cc,v $  $Revision: 1.1 $ 
$Date: 2000/12/02 10:09:13 $  by KyotoHydro
\end{verbatim}}

{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include "vary.h"
#include "data2str.h" // added by Y.Ichikawa (Thu Feb 15 15:51:10 1996)

template <class Type> 
Vary<Type>::Vary(void)
{
	size = 0;   v = NULL; 
}

template <class Type> 
Vary<Type>::Vary(int n)
{
	v = new Type[size = n];
}

template <class Type>
Vary<Type>::Vary(const Vary<Type>& a)
{
	v = new Type[size = a.size];
	for (int i = 0; i < size; i++)
		v[i] = a.Value(i);
}

template <class Type>
void Vary<Type>::Resize(int n)
{
	delete [] v;
	v = new Type[size = n];
}

template <class Type>
Vary<Type>& Vary<Type>::operator=(const Vary<Type>& a)
{
	if (this == &a)				
		return *this;
	delete [] v;
	v = new Type[size = a.size];
	for (int i = 0; i < size; i++)
		v[i] = a.Value(i);
	return *this;
}

template <class Type>
Vary<Type>::~Vary()
{
	delete [] v;
}
	
// *********************************************************************

template <class Type>
void dstr2data(char*& dstr, Vary<Type>& a)
{
 	int n;
 	dstr2data(dstr, n);
 	a.Resize(n);
 	for (int i = 0; i < n; i++)
 		dstr2data(dstr, a[i]);
}

// modified by Suzuki,T (Sat Feb 10 15:57:16 1996)
//template <class Type>
//void dstr2data(char*& dstr, Vary<Type>& a)
//{
//    char* tmp = dstr;
//
//    while (*tmp != '\0') {
//        while (*tmp == ' ' || *tmp == '\t') tmp++;
//        while (*tmp != ' ' && *tmp != '\t'
//               && *tmp != '\n' && *tmp != '\0') tmp++;
//        if (*tmp == '\0') break;
//        *tmp = '\0';
//        tmp++;
//    }
//
//    int n;
//    dstr2data(dstr, n);
//    a.Resize(n);
//    for (int i = 0; i < n; i++) dstr2data(dstr, a[i]);
//}

template <class Type>
void data2file(Vary<Type>& a, FILE* fp)
{
	int n = a.Size();
	data2file(n, fp);
	for (int i = 0; i < n; i++)
		data2file(a[i], fp);
}

template <class Type>
void data2ofile(Vary<Type>& a, FILE* fp)
{
 	int n = a.Size();
 	data2ofile(n, fp);
 	for (int i = 0; i < n; i++) {
 		fputc(' ', fp); data2ofile(a[i], fp);
	}
}
 
//// modified by Suzuki,T (Sat Feb 10 15:58:10 1996)
//template <class Type>
//void data2ofile(Vary<Type>& a, FILE* fp)
//{
//    int n = a.Size();
////  fputc('\"', fp);
//    fprintf(fp, "\" ");
//    data2ofile(n, fp);
//    for (int i = 0; i < n; i++)
//        { fputc(' ', fp); data2ofile(a[i], fp); }
////  fputc('\"', fp);
//    fprintf(fp, " \"");
//}


/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

